/* bind.c */

#ifndef lint
static char *rcsid = "$Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/bind.c,v 9.3 1993/03/19 22:53:23 isode Exp isode $";
#endif

/*
 * $Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/bind.c,v 9.3 1993/03/19 22:53:23 isode Exp isode $
 *
 *
 * $Log: bind.c,v $
 * Revision 9.3  1993/03/19  22:53:23  isode
 * Add QOS and DOS-DE code
 *
 * Revision 9.2  1992/12/15  07:05:26  awy
 * Update and fixes
 *
 * Revision 8.1  1991/09/13  14:36:41  isode
 * PARADISE Upgrade release
 *
 * Revision 8.0  91/07/17  13:18:35  isode
 * Release 7.0
 *
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */


/*****************************************************************************

  bind.c -

*****************************************************************************/

#define bind_c
#include "messages.h"
#include <stdio.h>
#include "bind.h"
#include "util.h"
#ifdef DOS
#include "proto-de.h"
#include <stdlib.h>
#include "msdos.h"
#endif DOS
#ifdef USELDAP
#include <string.h>
#ifdef IC
#include <ldap/lber.h>
#include <ldap/ldap.h>
#else
#include <lber.h>
#include <ldap.h>
#endif /* IC */
#include "isomanifest.h"
#include "demanifest.h"
#else
#include "quipu/common.h"
#include "quipu/bind.h"
#include "quipu/dap2.h"
#ifdef IC
#include "compat/logger.h"
#else
#include "logger.h"
#endif /* IC */
#endif USELDAP

extern char *dsa_address;
extern char *backup_dsa_address;
extern char *username;
extern char *password;
extern char callingDteNumber[];

extern int boundToDSA;
extern int deLogLevel;

#ifdef USELDAP
extern LDAP * ldap_ld;
extern char *ldapServer;
extern char * logfilename;
#ifndef DOS
extern FILE *de_log;
#endif DOS
#else
extern LLog *de_log;

/* this is not the way to do it */
extern int dsap_ad;

struct DAPconnect         dc;
struct DAPindication      di;

static int bindres;
static int triedBackup = FALSE;
static int bindStarted = FALSE;
#endif USELDAP
static int boundOnce = FALSE;

#ifndef USELDAP

int tryBackup()
{

  if (triedBackup == TRUE)
    return NOTOK;
  if (backup_dsa_address == NULLCP)
    return NOTOK;
  else
  {
    free(dsa_address);
    dsa_address = copy_string(backup_dsa_address);
    triedBackup = TRUE;
    return OK;
  }
}

/*
 * bind_to_ds - Bind to directory
 *
 */
int init_bind_to_ds(assoc)
int * assoc;
{
struct ds_bind_arg bind_arg;
struct PSAPaddr             *addr;
void exit();

  if (dsa_address == NULLCP)
  {
    (void) fprintf(stderr, NOADDRESS);
    exit(-1);
  }

  if (triedBackup == FALSE)
    if (boundOnce == FALSE)
      (void)printf(CONNECTING);

  bind_arg.dba_version = DBA_VERSION_V1988;
  bind_arg.dba_auth_type = DBA_AUTH_SIMPLE;

  bind_arg.dba_dn = str2dn(username);

  if (password == NULLCP)
  {
    bind_arg.dba_passwd[0] = '\0';
    bind_arg.dba_passwd_len = 0;
  }
  else
  {
    (void)strcpy(bind_arg.dba_passwd, password);
    bind_arg.dba_passwd_len = strlen(password);
  }

try_bind:

  if ((addr = str2paddr (dsa_address)) == NULLPA) {
    (void) fprintf(stderr, BADADDRESS);
    exit(-1);
  }
  bindres = DapAsynBindRequest(addr, &bind_arg, &dc, &di, ROS_ASYNC);
  if (bindres == NOTOK)
  {
    (void) fprintf(stderr, TEMPUNAVAIL);
    if (tryBackup() == OK)
    {
      (void) fprintf(stderr, TRYANOTHER);
      goto try_bind;
    }
    return NOTOK;
  }
  *assoc = dc.dc_sd;
  dsap_ad = dc.dc_sd;
  return OK;
}


int wait_bind_to_ds(assoc, wantToBlock)
int assoc;
int wantToBlock;
{
  struct PSAPindication   pi_s;
  struct PSAPindication   * pi = &(pi_s);
  int     nfds, nevents;
  fd_set  rfds;
  fd_set  wfds;


  while ((bindres == CONNECTING_1) || (bindres == CONNECTING_2)) 
  {

    FD_ZERO (&rfds);
    FD_ZERO (&wfds);

    if ((bindres == CONNECTING_2) && (wantToBlock == FALSE))
      return CONNECTING_2;

    if (bindres == CONNECTING_1) 
    {
      if (PSelectMask (assoc, &wfds, &nfds, pi) == NOTOK) 
      {
         (void) fprintf(stderr, "PSelectMask (write) failed\n");
         return NOTOK;
      }
    }

    if (bindres == CONNECTING_2) 
    {
      if (PSelectMask (assoc, &rfds, &nfds, pi) == NOTOK) 
      {
        (void) fprintf(stderr, "PSelectMask (read) failed\n");
        return NOTOK;
      }
    }

    nevents = xselect (nfds, &rfds, &wfds, NULLFD, NOTOK);
  
    if (nevents == NOTOK) 
    {
      (void) fprintf(stderr, "xselect failed\n");
      return NOTOK;
    } 
    else 
    {
      /*
       * Hack coming up: nevents is number of events, we only asked for
       * one event, so unless there are no events we go ahead without
       * checking those horrid fd things, which would be safer.
       */
       if (nevents != OK) 
         bindres = DapAsynBindRetry(assoc, 0, &dc, &di);
    }
  
    if (bindres == DONE)
    {
      if (dc.dc_result != DC_RESULT)
      {
        if (dc.dc_un.dc_bind_err.dbe_type == DBE_TYPE_SECURITY)
 	{
	  if (dc.dc_un.dc_bind_err.dbe_value == DSE_SC_INVALIDCREDENTIALS)
	  {
	    (void)fprintf(stderr, NOBIND1);
	  }
	  else if (dc.dc_un.dc_bind_err.dbe_value == DSE_SC_AUTHENTICATION)
            (void)fprintf(stderr, NOBIND2);
	}
        else
	  (void)fprintf(stderr, NOBIND3, 
	    dc.dc_un.dc_bind_err.dbe_type, dc.dc_un.dc_bind_err.dbe_value);
        return NOTOK;
      }
      boundToDSA = TRUE;
      boundOnce = TRUE;
      if (deLogLevel)
        (void) ll_log (de_log, LLOG_NOTICE, NULLCP, "Bound: %s", callingDteNumber);
      return OK;
    }
  }
  if (tryBackup() == OK)
    if (init_bind_to_ds(&assoc) == OK)
      return OK;
  (void)fprintf(stderr, BINDFAIL);
  return NOTOK; /* exit this way if can't talk to access point(s) */
} /* bind_to_ds */

#endif USELDAP

int
rebind()
{
  if (boundToDSA == FALSE)
    return(de_bind(TRUE));
  else
    return OK;
}

int 
de_bind(wantToBlock)
int wantToBlock;
{
#ifndef USELDAP
static int assoc;
#endif

#ifdef USELDAP
  if (ldapServer == NULLCP)
  {
    (void) fprintf(stderr, NOLDAPSERV);
    exit(-1);
  }
  if (boundOnce == FALSE)
    (void)printf(CONNECTING);
  if ((ldap_ld = ldap_open(ldapServer, LDAP_PORT)) == NULL )
  {
    (void) printf(NOLDAPCONN, ldapServer);
    (void) de_exit(-1);
  }

  ldap_ld->ld_deref = LDAP_DEREF_ALWAYS;

  if (ldap_bind(ldap_ld, username, password, LDAP_AUTH_SIMPLE)
                != LDAP_SUCCESS)
  {
    (void) printf(NOLDAPCONN, ldapServer);
    ldap_perror(ldap_ld, LDREASON);
    (void) de_exit(-1);
  }
#ifndef DOS
  if (deLogLevel)
    (void) fprintf (de_log, "Bound:\n");
#endif DOS
  boundToDSA = TRUE;
  boundOnce = TRUE;
#else
  if (bindStarted == FALSE)
  {
    if (init_bind_to_ds(&assoc) != OK)
      return NOTOK;
    bindStarted = TRUE;
    if (wantToBlock == FALSE)
      return OK;
  }
  if (wait_bind_to_ds(assoc, wantToBlock) == NOTOK) /* don`t block */
    return NOTOK;
#endif USELDAP
  return OK;
}

void
de_unbind()
{
#ifdef USELDAP
#ifndef DOS
  if (deLogLevel)
    (void) fprintf (de_log, "Unbind:\n");
#endif DOS
  ldap_unbind(ldap_ld);
  boundToDSA = FALSE;
#else
  if (deLogLevel)
    (void) ll_log (de_log, LLOG_NOTICE, NULLCP, "Unbind:");
  (void) ds_unbind();
  boundToDSA = FALSE;
  bindStarted = FALSE;
#endif USELDAP
}

