/* country.c - search for a country */

#ifndef lint
static char *rcsid = "$Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/country.c,v 9.3 1993/03/19 22:53:46 isode Exp isode $";
#endif

/*
 * $Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/country.c,v 9.3 1993/03/19 22:53:46 isode Exp isode $
 *
 *
 * $Log: country.c,v $
 * Revision 9.3  1993/03/19  22:53:46  isode
 * Add QOS and DOS-DE code
 *
 * Revision 9.2  1992/12/15  07:05:26  awy
 * Update and fixes
 *
 * Revision 8.1  1991/09/13  14:36:41  isode
 * PARADISE Upgrade release
 *
 * Revision 8.0  91/07/17  13:18:38  isode
 * Release 7.0
 *
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */

#define country_c
#ifdef DOS
#include <stdlib.h>
#include "proto-de.h"
#endif DOS
#include "messages.h"
#include <signal.h>
#ifdef USELDAP
#ifdef IC
#include <ldap/lber.h>
#include <ldap/ldap.h>
#else
#include <lber.h>
#include <ldap.h>
#endif /* IC */
#include <string.h>
#include "isomanifest.h"
#ifdef DOS
#include <msdos.h>
#else
#include <sys/time.h>
#endif DOS
#else
#include "quipu/util.h"
#include "quipu/read.h"
#include "quipu/list.h"
#include "quipu/ds_search.h"
#include "quipu/dua.h"
#endif USELDAP
#include "demanifest.h"
#include "namelist.h"
#include "filter.h"
#include "destrings.h"

#ifndef USELDAP
extern char filbuf[];
struct ds_read_arg rarg;
struct ds_read_result rresult;

struct ds_list_arg larg;
struct ds_list_result lresult;

struct ds_search_arg sarg;
struct ds_search_result sresult;
struct DSError serror;
#endif USELDAP

extern int abandoned;
extern int highNumber;
extern int exactMatch;
extern int fuzzyMatching;
extern int gotFuzzyMatch;
extern char exactString[];

extern struct namelist * coatts;

int listAtRoot = TRUE;

#ifdef USELDAP
extern LDAP * ldap_ld;
extern char * ldap_base;
extern int ldap_scope;
extern char ldap_filter[BUFSIZ];
extern char ** ldap_attrs;
extern char ldap_attrsonly;
extern int ldap_msgid;
extern int ldap_all;
extern struct timeval ldap_timeout;
extern LDAPMessage * ldap_res;
LDAPMessage * entry_dup();
void fillMostCountryReadArgs();
void fillMostCountryListArgs();
void fillMostCountrySearchArgs();
#else
struct ds_read_arg *fillMostCountryReadArgs();
struct ds_list_arg *fillMostCountryListArgs();
struct ds_search_arg *fillMostCountrySearchArgs();
Filter get_filter();
#endif USELDAP

void makeExplicitCoFilter();
void coFilter1(), coFilter2(), coFilter3(), coFilter4();

VFP explicitCo[] = {makeExplicitCoFilter, NULLVFP};
VFP normalCo[] = {coFilter1, coFilter2, coFilter3, coFilter4, NULLVFP};

int
makeRootCountry(clistp)
struct namelist ** clistp;
{
	*clistp = list_alloc();
	(*clistp)->name = copy_string("root");
#ifdef USELDAP
        (*clistp)->ats = NULLMSG;
#else
	(*clistp)->ats = NULLATTR;
#endif USELDAP
	(*clistp)->next = NULLLIST;
	return OK;
}
		
int
listCos(cstr, clistp)
char * cstr;
struct namelist ** clistp;
{
	clearProblemFlags();
	initAlarm();	
	if (exactMatch == COUNTRY)
	  return(listExactCos(exactString, clistp));
        else if (strcmp(cstr, "*") == 0)
          return(listAllCos(clistp));
	else if (strcmp(cstr, "-") == 0)
	  return(makeRootCountry(clistp)); /* make the root a "country" to 
      	                       enable searching under the root of the tree */
        else
          return(listMatchingCos(cstr, clistp));
}

void
printListCos(cstr, clistp)
char * cstr;
struct namelist * clistp;
{
struct namelist * x;
int i;

	if (clistp == NULLLIST)
		pageprint(NOCOSMATCH);
	else
	{
		for (i =1, x = clistp; x != NULLLIST; i++, x = x->next)
			printLastComponent(INDENTON, x->name, COUNTRY, i);
		showAnyProblems(cstr);
	}
}

void
freeCos(listpp)
struct namelist ** listpp;
{
struct namelist * x, * y;

	x = *listpp;
	while (x != NULLLIST)
	{
		if (x->name != NULLCP)
			free(x->name);
#ifdef USELDAP
		if (x->ats) ldap_msgfree(x->ats);
#else
		as_free(x->ats);
#endif USELDAP
		y = x->next;
		free((char *)x);
		x = y;
	}
	*listpp = NULLLIST;
}

void
freeCoReadArgs()
{
#ifdef USELDAP
        freeLdapOpArgs();
#endif USELDAP
}

void
freeCoListArgs()
{
#ifdef USELDAP
	freeLdapOpArgs();
#else
	dn_free(larg.lsa_object);
#endif USELDAP
}

void
freeCoSearchArgs()
{
#ifdef USELDAP
	freeLdapOpArgs();
#else
	dn_free(sarg.sra_baseobject);
#endif USELDAP
}

listAllCos(clistp)
struct namelist ** clistp;
{
int ret;

	if (listAtRoot == TRUE)
	{
#ifdef USELDAP
		fillMostCountryListArgs();
#else
		larg = * fillMostCountryListArgs();
#endif USELDAP
		ret = reallyMakeListCountries(clistp);
	}
	else
	{
#ifdef USELDAP
	        fillMostCountrySearchArgs("", LDAP_SCOPE_ONELEVEL);
	        makeAllCoFilter();
#else
	        sarg = * fillMostCountrySearchArgs(NULLCP, SRA_ONELEVEL);
	        makeAllCoFilter(&sarg.sra_filter);
#endif USELDAP
	        ret = makeListCountries(clistp);
	}
        if (ret != OK)
		logListSuccess(LIST_ERROR, "co", 0);
	else
		logListSuccess(LIST_OK, "co", listlen(*clistp));
						
	if (listAtRoot == TRUE)
		freeCoListArgs();
	else
		freeCoSearchArgs();
	alarmCleanUp();
	return ret;
}

listMatchingCos(cstr, clistp)
char * cstr;
struct namelist ** clistp;
{
VFP * filtarray;
VFP filterfunc;
int filtnumber;
int ret;
char str[5];

	/* if 2 letter country entered - let's see if we can read the entry*/
	if (strlen(cstr) == 2)
	{
		(void) sprintf(str, "%s=%s", SHORT_CO, cstr);
		ret = readCo(str, clistp);
		if (ret == OK)
		{
			alarmCleanUp();
			return OK;
		}
	}

        if (index(cstr, '*') != NULLCP) /* contains at least one asterisk */
	{
                filtarray = explicitCo;
		filtnumber = -1;
	}
        else
	{
                filtarray = normalCo;
		filtnumber = 0;
	}
#ifdef USELDAP
	fillMostCountrySearchArgs("", LDAP_SCOPE_ONELEVEL);
	(void) sprintf(str, "%s=%s", SHORT_CO, cstr);
#else
	sarg = * fillMostCountrySearchArgs(NULLCP, SRA_ONELEVEL);
#endif USELDAP
        while ((filterfunc = *filtarray++) != NULLVFP)
	{
		filtnumber++;
#ifdef USELDAP
                filterfunc(cstr);
		if (ldap_filter == NULLCP)
			continue;
#else
                filterfunc(cstr, &sarg.sra_filter);
		if (sarg.sra_filter == NULLFILTER)
			continue;
#endif USELDAP
                ret = makeListCountries(clistp);
		if ((ret != OK) && (ret != PROTREJECT))
		{ 	
			freeCoSearchArgs();
			logSearchSuccess(SEARCH_ERROR, "co", cstr, filtnumber, 0);
			alarmCleanUp();
			return NOTOK;
		}
                if (*clistp != NULLLIST)
                        break;
	}
	if (*clistp != NULLLIST)
		logSearchSuccess(SEARCH_OK, "co", cstr, filtnumber, listlen(*clistp));
	else
		logSearchSuccess(SEARCH_FAIL, "co", cstr, filtnumber, 0);
	freeCoSearchArgs();
	alarmCleanUp();
	return OK;
}

readCo(objectstr, clistp)
char * objectstr;
struct namelist ** clistp;
{
int retval;
#ifdef USELDAP
LDAPMessage * enp;
#endif USELDAP

#ifdef USELDAP
	fillMostCountryReadArgs(objectstr);
	retval = de_read();
#else
	rarg = * fillMostCountryReadArgs(objectstr);
	retval = de_read(&rarg, &serror, &rresult);
/*	if ((retval == DSE_INTR_ABANDONED) &&
	    (serror.dse_type == DSE_ABANDONED))
	         abandoned = TRUE; */
#endif USELDAP
	if (retval != OK)
		return retval;
	/* setProblemFlags(rresult); */

	*clistp = list_alloc();
#ifdef USELDAP
	if (ldap_count_entries(ldap_ld, ldap_res) > 0) {
		enp = ldap_first_entry(ldap_ld, ldap_res);
		(*clistp)->name = ldap_get_dn(ldap_ld, enp);
		(*clistp)->ats = entry_dup(enp);
	}
	else
		return NOTOK;
#else
	(*clistp)->name = dn2pstr(rresult.rdr_entry.ent_dn);
	(*clistp)->ats = as_cpy(rresult.rdr_entry.ent_attr);
#endif USELDAP
	(*clistp)->next = NULLLIST;
	highNumber = 1;
	return OK;
	
}

listExactCos(objectstr, clistp)
char * objectstr;
struct namelist ** clistp;
{
int ret;

#ifdef USELDAP
        fillMostCountrySearchArgs(objectstr, LDAP_SCOPE_BASE);
        makeAllCoFilter();
        ret = makeListCountries(clistp);
#else
        sarg = * fillMostCountrySearchArgs(objectstr, SRA_BASEOBJECT);
        makeAllCoFilter(&sarg.sra_filter);
        ret = makeListCountries(clistp);
#endif USELDAP
	freeCoSearchArgs();
	alarmCleanUp();
	return ret;
}

reallyMakeListCountries(clistp)
struct namelist ** clistp;
{
int retval;
#ifdef USELDAP
LDAPMessage * enp;
#else
struct subordinate * x;
char * cp;
#endif USELDAP

	if (rebind() != OK)
                 return NOTOK;
#ifdef USELDAP
	retval = de_list();
#else
	retval = de_list(&larg, &serror, &lresult);
	/* if ((retval == DSE_INTR_ABANDONED) &&
	    (serror.dse_type == DSE_ABANDONED))
	        abandoned = TRUE; */
#endif USELDAP
	if (retval != OK)
		 return retval;

	/* setProblemFlags(sresult); */
	highNumber = 0;
#ifdef USELDAP
	if (ldap_count_entries(ldap_ld, ldap_res) > 0)
	    for (enp = ldap_first_entry(ldap_ld, ldap_res); enp != NULL;
				enp = ldap_next_entry(ldap_ld, enp))
	{
		*clistp = list_alloc();
		(*clistp)->name = ldap_get_dn(ldap_ld, enp);
		(*clistp)->ats = NULLMSG;
		clistp = &(*clistp)->next;
		highNumber++;
	}
#else
	for (x = lresult.lsr_subordinates; x != (struct subordinate *) NULL;
	                                   x = x->sub_next)
	{
		/* only add countries and localities to the list */
		cp = strdup(attr2name(x->sub_rdn->rdn_at, OIDPART));
		if ((strcmp(cp, DE_COUNTRY_NAME) == 0) ||
		    (strcmp(cp, DE_LOCALITY_NAME) == 0))
		{
			*clistp = list_alloc();
			(*clistp)->name = rdn2pstr(x->sub_rdn);
			(*clistp)->ats = NULLATTR;
			clistp = &(*clistp)->next;
			highNumber++;
		}
		free(cp);
	}
#endif USELDAP
	*clistp = NULLLIST;
#ifndef USELDAP
	/* free something */
	dn_free (lresult.lsr_object);
	/* free something else */
#endif USELDAP
	return OK;
}

#ifdef USELDAP
makeListCountries(clistp)
struct namelist ** clistp;
{
LDAPMessage * enp;
/* static char * atpp[] = {"countryName", 0}; */
int retval;

	if (rebind() != OK)
		return NOTOK;
	retval = de_search();
	if (retval != OK)
	{
		*clistp = NULLLIST;
		return retval;
	}
        highNumber = 0;
        if (ldap_count_entries(ldap_ld, ldap_res) > 0)
            for (enp = ldap_first_entry(ldap_ld, ldap_res); enp != NULL;
                                        enp = ldap_next_entry(ldap_ld, enp))
        {
                *clistp = list_alloc();
                (*clistp)->name = ldap_get_dn(ldap_ld, enp);
                (*clistp)->ats = entry_dup(enp);
                clistp = &(*clistp)->next;
                highNumber++;
        }
        *clistp = NULLLIST;
        return OK;
}
#else
makeListCountries(clistp)
struct namelist ** clistp;
{
entrystruct * x;
int retval;

	if (rebind() != OK)
		return NOTOK;
	retval = de_search(&sarg, &serror, &sresult);
	/*if ((retval == DSE_INTR_ABANDONED) &&
	    (serror.dse_type == DSE_ABANDONED))
		abandoned = TRUE;*/
	if (retval != OK)
	{
		*clistp = NULLLIST;
		filter_free(sarg.sra_filter);
		return retval;
	}
	correlate_search_results (&sresult);

	setProblemFlags(sresult);

	highNumber = 0;
	for (x = sresult.CSR_entries; x != NULLENTRYINFO; x = x->ent_next) {
		*clistp = list_alloc();
		(*clistp)->name = dn2pstr(x->ent_dn);
		(*clistp)->ats = as_cpy(x->ent_attr);
		clistp = &(*clistp)->next;
		highNumber++;
	}
	*clistp = NULLLIST;
	entryinfo_free(sresult.CSR_entries,0);
	dn_free (sresult.CSR_object);
	crefs_free (sresult.CSR_cr);
	filter_free(sarg.sra_filter);
	return OK;
}
#endif USELDAP

#ifdef USELDAP
void
fillMostCountryReadArgs(objectstr)
char * objectstr;
{
	ldap_base = removeLastRDN(objectstr);
	ldap_scope = LDAP_SCOPE_ONELEVEL;
	ldap_attrs = makeAllAttrs(coatts);
	ldap_attrsonly = 1;
	ldap_all = 1;
	ldap_timeout.tv_sec = 2;
	ldap_timeout.tv_usec = 0;
	(void)sprintf(ldap_filter, "(%s)", lastRDN(objectstr));
}
#else
struct ds_read_arg *
fillMostCountryReadArgs(objectstr)
char * objectstr;
{
static struct ds_read_arg arg;
static CommonArgs sca = default_common_args;
Attr_Sequence * atl;
AttributeType at;
struct namelist * x;

	arg.rda_common =sca; /* struct copy */
	arg.rda_common.ca_servicecontrol.svc_timelimit = SVC_NOTIMELIMIT;
	arg.rda_common.ca_servicecontrol.svc_sizelimit= SVC_NOSIZELIMIT;

	arg.rda_object = str2dn(objectstr);
	/* specify attributes of interest */
	arg.rda_eis.eis_allattributes = FALSE;
	atl = &(arg.rda_eis.eis_select);
	for (x = coatts; x != NULLLIST; x = x->next)
	{
		if ((at = str2AttrT(x->name)) == NULLAttrT)
		    continue;
		*atl = as_comp_alloc();
		(*atl)->attr_type = at;
		(*atl)->attr_value = NULLAV;
		atl = &(*atl)->attr_link;
	}
	*atl = NULLATTR;
	arg.rda_eis.eis_infotypes = EIS_ATTRIBUTESANDVALUES;
	return (&arg);
}
#endif USELDAP

#ifdef USELDAP
void
fillMostCountryListArgs()
{
	ldap_base = copy_string("");
	ldap_scope = LDAP_SCOPE_ONELEVEL;
	ldap_attrs = makeAllAttrs(coatts);
	ldap_attrsonly = 1;
	ldap_all = 1;
	ldap_timeout.tv_sec = 2;
	ldap_timeout.tv_usec = 0;
	(void)sprintf(ldap_filter,
		"(|(objectclass=country)(objectclass=locality))");
}
#else
struct ds_list_arg *
fillMostCountryListArgs()
{
static struct ds_list_arg arg;
static CommonArgs sca = default_common_args;

	arg.lsa_common =sca; /* struct copy */
	arg.lsa_common.ca_servicecontrol.svc_timelimit = SVC_NOTIMELIMIT;
	arg.lsa_common.ca_servicecontrol.svc_sizelimit= SVC_NOSIZELIMIT;

	arg.lsa_object = str2dn("");
	return (&arg);
}
#endif USELDAP

#ifdef USELDAP
void
fillMostCountrySearchArgs(objectstr, searchdepth)
char * objectstr;
int searchdepth;
{
	ldap_base = copy_string(objectstr);
	ldap_scope = searchdepth;
	ldap_attrs = makeAllAttrs(coatts);
	ldap_attrsonly = 0;
	ldap_all = 1;
	ldap_timeout.tv_sec = 2;
	ldap_timeout.tv_usec = 0;
}
#else
struct ds_search_arg *
fillMostCountrySearchArgs(objectstr, searchdepth)
char * objectstr;
int searchdepth;
{
static struct ds_search_arg arg;
static CommonArgs sca = default_common_args;
Attr_Sequence * atl;
AttributeType at;
struct namelist * x;

	arg.sra_common = sca; /* struct copy */
        arg.sra_common.ca_servicecontrol.svc_timelimit = SVC_NOTIMELIMIT;
        arg.sra_common.ca_servicecontrol.svc_sizelimit= SVC_NOSIZELIMIT;

	arg.sra_subset = searchdepth;
	arg.sra_baseobject = str2dn(objectstr);
	/* specify attributes of interest */
	arg.sra_eis.eis_allattributes = FALSE;
	atl = &(arg.sra_eis.eis_select);
	for (x = coatts; x != NULLLIST; x = x->next)
	{
		if ((at = str2AttrT(x->name)) == NULLAttrT)
		    continue;
		*atl = as_comp_alloc();
		(*atl)->attr_type = at;
		(*atl)->attr_value = NULLAV;
		atl = &(*atl)->attr_link;
	}
	*atl = NULLATTR;
	arg.sra_eis.eis_infotypes = EIS_ATTRIBUTESANDVALUES;
	return (&arg);
}
#endif USELDAP

#ifdef USELDAP
#ifdef DOS
void
#endif DOS
makeAllCoFilter()
{
        gotFuzzyMatch = FALSE;
        (void)strcpy(ldap_filter, "(|(objectclass=country)(objectclass=locality))");
}
#else
makeAllCoFilter(fpp)
struct s_filter ** fpp;
{
        gotFuzzyMatch = FALSE;
	(void)sprintf(filbuf, "(%s=%s) | (%s=%s)", DE_OBJECT_CLASS, 
		DE_COUNTRY, DE_OBJECT_CLASS, DE_LOCALITY);
	*fpp = get_filter(filbuf);
}
#endif USELDAP

#ifdef USELDAP
void
makeExplicitCoFilter(cstr)
char * cstr;
{
        gotFuzzyMatch = FALSE;
        (void)sprintf(ldap_filter, "(&(|(objectclass=country)(objectclass=locality))");
        (void)sprintf(ldap_filter, "%s (|(c=%s)(co=%s))",
                     ldap_filter, cstr, cstr);
        (void)sprintf(ldap_filter, "%s(localityName=%s)", ldap_filter, cstr);
}
#else
void
makeExplicitCoFilter(cstr, fpp)
char * cstr;
struct s_filter ** fpp;
{
        gotFuzzyMatch = FALSE;
	(void)sprintf(filbuf, "((%s=%s)|(%s=%s)) & ((%s=%s)|(%s=%s)|(%s=%s))",
		DE_OBJECT_CLASS, DE_COUNTRY, DE_OBJECT_CLASS, DE_LOCALITY,
		DE_COUNTRY_NAME, cstr, DE_FRIENDLY_COUNTRY, cstr,
		DE_LOCALITY_NAME, cstr);
	*fpp = get_filter(filbuf);
}
#endif USELDAP

#ifdef USELDAP
void
coFilter1(cstr)
char * cstr;
{
        gotFuzzyMatch = FALSE;
        (void)sprintf(ldap_filter, "(|(&(objectclass=country)");
        if (strlen(cstr) == 2)
                (void)sprintf(ldap_filter,  "%s(c=%s))", ldap_filter, cstr);
        else
                (void)sprintf(ldap_filter,  "%s(co=%s))", ldap_filter, cstr);
        (void)sprintf(ldap_filter,  "%s(&(objectclass=locality)(l=%s)))",
                ldap_filter, cstr);
}
#else
void
coFilter1(cstr, fpp)
char * cstr;
struct s_filter ** fpp;
{

        gotFuzzyMatch = FALSE;
	(void)sprintf(filbuf, "((%s=%s)&", DE_OBJECT_CLASS, DE_COUNTRY);
	if ((strlen(cstr) == 2) && (check_3166(cstr)))
		(void)sprintf(filbuf, "%s(%s=%s))", filbuf, DE_COUNTRY_NAME, cstr);
	else
		(void)sprintf(filbuf, "%s(%s=%s))", filbuf, DE_FRIENDLY_COUNTRY, cstr);
	(void)sprintf(filbuf, "%s|((%s=%s)&(%s=%s))", filbuf,
		DE_OBJECT_CLASS, DE_LOCALITY, DE_LOCALITY_NAME, cstr);
	*fpp = get_filter(filbuf);
}
#endif USELDAP

#ifdef USELDAP
void
coFilter2(cstr)
char * cstr;
{
        gotFuzzyMatch = FALSE;
        (void)sprintf(ldap_filter, "(|(&(objectclass=country)");
        (void)sprintf(ldap_filter,  "%s(co=%s*))", ldap_filter, cstr);
        (void)sprintf(ldap_filter,  "%s(&(objectclass=locality)(l=%s*)))",
                ldap_filter, cstr);
}
#else
void
coFilter2(cstr, fpp)
char * cstr;
struct s_filter ** fpp;
{
        gotFuzzyMatch = FALSE;
	(void)sprintf(filbuf, "((%s=%s)|(%s=%s)) & ((%s=%s*)|(%s=%s*))",
		DE_OBJECT_CLASS, DE_COUNTRY, DE_OBJECT_CLASS, DE_LOCALITY,
		DE_FRIENDLY_COUNTRY, cstr,
		DE_LOCALITY_NAME, cstr);
	*fpp = get_filter(filbuf);
}
#endif USELDAP

#ifdef USELDAP
void
coFilter3(cstr)
char * cstr;
{
        gotFuzzyMatch = FALSE;
        (void)sprintf(ldap_filter, "(|(&(objectclass=country)");
        (void)sprintf(ldap_filter,  "%s(co=*%s*))", ldap_filter, cstr);
        (void)sprintf(ldap_filter,  "%s(&(objectclass=locality)(l=*%s*)))",
                ldap_filter, cstr);
}
#else
void
coFilter3(cstr, fpp)
char * cstr;
struct s_filter ** fpp;
{
        gotFuzzyMatch = FALSE;
	(void)sprintf(filbuf, "((%s=%s)|(%s=%s)) & ((%s=*%s*)|(%s=*%s*))",
		DE_OBJECT_CLASS, DE_COUNTRY, DE_OBJECT_CLASS, DE_LOCALITY,
		DE_FRIENDLY_COUNTRY, cstr,
		DE_LOCALITY_NAME, cstr);
	*fpp = get_filter(filbuf);
}
#endif USELDAP

#ifdef USELDAP
void
coFilter4(cstr)
char * cstr;
{
	if (fuzzyMatching == FALSE)
	{
		(void)strcpy(ldap_filter, "");
		return;
	}
        gotFuzzyMatch = TRUE;
        (void)sprintf(ldap_filter, "(|(&(objectclass=country)");
        (void)sprintf(ldap_filter,  "%s(co~=%s))", ldap_filter, cstr);
        (void)sprintf(ldap_filter,  "%s(&(objectclass=locality)(l~=%s)))",
                ldap_filter, cstr);
}
#else
void
coFilter4(cstr, fpp)
char * cstr;
struct s_filter ** fpp;
{
	if (fuzzyMatching == FALSE)
	{
		*fpp = NULLFILTER;
		return;
	}
        gotFuzzyMatch = TRUE;
	(void)sprintf(filbuf, "((%s=%s)|(%s=%s)) & ((%s~=%s)|(%s~=%s))",
		DE_OBJECT_CLASS, DE_COUNTRY, DE_OBJECT_CLASS, DE_LOCALITY,
		DE_FRIENDLY_COUNTRY, cstr,
		DE_LOCALITY_NAME, cstr);
	*fpp = get_filter(filbuf);
}
#endif USELDAP
