/* deqos.c - routines for quality of service stuff */

#ifndef lint
static char *rcsid = "$Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/deqos.c,v 9.3 1993/03/19 22:54:03 isode Exp isode $";
#endif

/*
 * $Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/deqos.c,v 9.3 1993/03/19 22:54:03 isode Exp isode $
 *
 *
 * $Log: deqos.c,v $
 * Revision 9.3  1993/03/19  22:54:03  isode
 * Add QOS and DOS-DE code
 *
 * Revision 9.2  1993/02/20  20:05:06  isode
 * IC-R1 base
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */

#ifndef DOS
#define deqos_c

#ifdef QOS
#include <sys/stat.h>
#include <unistd.h>
#include <stdio.h>
#include <malloc.h>

#include "messages.h"

#ifndef USELDAP
#ifdef IC
#include "compat/tailor.h"
#else
#include "tailor.h"
#endif IC
#include "quipu/util.h"
#else 
#include "isomanifest.h"
#include "demanifest.h"
#endif USELDAP

FILE *qos_file;
time_t initial_time;
time_t final_time;
int secondsAlarm;
char waitMessage[LINESIZE];

extern int qosOn;
extern char qosfilename[LINESIZE];

void
initFinalTime()
{
  final_time = -1;
}

void
formatWaitMessage(seconds, count)
int seconds;
int count;
{
  if (count == 0)
    (void) sprintf(waitMessage, OPSOMETIME);
  else if (seconds < 0)
  {
    if (count < 5)
      (void) strcpy(waitMessage, LASTFEWNOGOOD);
    else
      (void) strcpy(waitMessage, USUALLYNOGOOD);
  }
  else if (seconds < 21)
  {
    if (count < 5)
      (void) sprintf(waitMessage,
      		"%s20 %s%s", LASTFEW, SECONDS, PLEASEWAIT);
    else
      (void) sprintf(waitMessage,
      		"%s20 %s%s", USUALLYTAKES, SECONDS, PLEASEWAIT);
  }
  else if (seconds < 31)
  {
    if (count < 5)
      (void) sprintf(waitMessage,
      		"%s30 %s%s", LASTFEW, SECONDS, PLEASEWAIT);
    else
      (void) sprintf(waitMessage,
      		"%s30 %s%s", USUALLYTAKES, SECONDS, PLEASEWAIT);
  }
  else if (seconds < 61)
  {
    if (count < 5)
      (void) sprintf(waitMessage, "%s%s%s", LASTFEW, MINUTE, PLEASEWAIT);
    else
      (void) sprintf(waitMessage, "%s%s%s", USUALLYTAKES, MINUTE, PLEASEWAIT);
  }
  else if (seconds < 181)
  {
    if (count < 5)
      (void) sprintf(waitMessage,
      		"%s%s%s", LASTFEWTOOKOVER, MINUTE, PLEASEWAIT);
    else
      (void) sprintf(waitMessage,
      		"%s%s%s\n", USUALLYTAKESOVER, MINUTE, PLEASEWAIT);
  }
  else
  {
    if (count < 5)
      (void) sprintf(waitMessage,
      		"%s%s...\n", LASTFEWTOOKOVER, THREEMINUTES);
    else
      (void) sprintf(waitMessage,
      		"%s%s...\n", USUALLYTAKESOVER, THREEMINUTES);
  }
  (void) strcat(waitMessage, CONTROLC);
}

void    updateStats(matchstring, seconds, count)
char matchstring[];
int seconds;
int count;
{
int new_seconds;
int new_count;
char * local_dn;
char * new_sec_char;
char * new_count_char;
char * new_line;
void counterCleanUp();

  local_dn       = malloc(100);
  new_sec_char   = malloc(4);
  new_count_char = malloc(4);
  new_line       = malloc(111);

  if (final_time > -1)
    final_time = time(0);

  if (seconds < 0)            /* Prev data indicated failure */
  {
    if (final_time > -1)    /* This time was success */
    {
      new_seconds = final_time - initial_time;
      new_count = 1;
    }
    else
    {
      new_seconds = -1;
      new_count = ++count;
    }
  }
  else
  {
    if (final_time > -1)    /* Success again */
    {
      new_count = ++count;
      new_seconds = (seconds + (final_time - initial_time))/2;
    }
    else 		 /* First time fail */
    {
      new_seconds = -1;
      new_count = 1;
    }
  }

  (void) sprintf(local_dn, "%-99.99s", matchstring);
  if (new_seconds > 0)
    (void) sprintf(new_sec_char, "%4.0d", new_seconds);
  else if (new_seconds == 0)
    (void) sprintf(new_sec_char, "%s", "   0");
  else
    (void) sprintf(new_sec_char, "%s", "  -1");

  (void) sprintf(new_count_char, "%4.0d", new_count);
  (void) sprintf(new_line, "%s&%s &%s\n", local_dn, new_sec_char, new_count_char);
  (void) fputs(new_line, qos_file);
  (void) fclose(qos_file);

  free(local_dn);
  free(new_sec_char);
  free(new_count_char);
  free(new_line);
}

void    addToStats(matchstring)
char matchstring[];
{
char * local_dn;
char * new_sec_char;
char * new_count_char;
char * new_line;
int new_count;
int new_seconds;
void counterCleanUp();

  local_dn       = malloc(100);
  new_sec_char   = malloc(4);
  new_count_char = malloc(4);
  new_line       = malloc(111);

  (void) fclose(qos_file);
  if ((qos_file = fopen(qosfilename, "a")) == (FILE *) NULL)
    (void) fprintf(stderr, "Error opening qos file");
  new_count = 1;
  if (final_time > -1 )
  {
    final_time = time(0);
    new_seconds = final_time - initial_time;
  }
  else
    new_seconds = -1;

  (void) sprintf(local_dn, "%-99.99s", matchstring);
  if (new_seconds > 0)
    (void) sprintf(new_sec_char, "%4.0d", new_seconds);
  else if (new_seconds == 0)
    (void) sprintf(new_sec_char, "%s", "   0");
  else
    (void) sprintf(new_sec_char, "%s", "  -1");
  (void) sprintf(new_count_char, "%4.0d", new_count);
  (void) sprintf(new_line, "%s&%s &%s\n", local_dn, new_sec_char, new_count_char);
  (void) fputs(new_line, qos_file);
  (void) fclose(qos_file);
  free(local_dn);
  free(new_sec_char);
  free(new_count_char);
  free(new_line);
}

void deqos(matchstring, fnd_qos_file, fnd_qos_rec, seconds, count)
char matchstring[];
int *fnd_qos_file;
int *fnd_qos_rec;
int *seconds;
int *count;
{
char system_command[LINESIZE];
char *linebuf;
char * posptr;
char * ptr1;
char * ptr2;
char * sec_char;
char * tmp_match;
int status;

  if (qosOn == FALSE)
    return;
  linebuf   = malloc(LINESIZE);
  sec_char  = malloc(LINESIZE);
  tmp_match = malloc(LINESIZE);
    
  initial_time = time(0);
  final_time = initial_time;
  secondsAlarm = 0;
  (void) sprintf(tmp_match, "%s%s", matchstring, " ");
  formatWaitMessage(0,0);
  if ((qos_file = fopen(qosfilename, "r+")) == (FILE *) NULL)
    *fnd_qos_file = FALSE;
  else
  {
    *fnd_qos_file = TRUE;
    status = ftell(qos_file);
    *fnd_qos_rec = FALSE;
    while(fgets(linebuf, LINESIZE, qos_file) != NULLCP)
    {
      if (!(strncmp(linebuf, tmp_match, (strlen(matchstring)+1))))
      {
        /* valid record */
	*fnd_qos_rec = TRUE;
	ptr1 = index(linebuf, '&');
	ptr2 = index(++ptr1, '&');
	(void) sprintf(sec_char, "%s", "          ");
	(void) strncpy(sec_char, ptr1, ptr2-ptr1-1);
        *seconds = atoi(sec_char);
	secondsAlarm = *seconds;
	ptr1 = ++ptr2;
	ptr2 = index(ptr2, '\n');
	(void) sprintf(sec_char, "%s", "          ");
	(void) strncpy(sec_char, ptr1, ptr2-ptr1);
	*count = atoi(sec_char);
	formatWaitMessage(*seconds, *count);
	break;
      }
      status = ftell(qos_file);
    }
    status = fseek(qos_file, status, SEEK_SET);
  }
  free(linebuf);
  free(sec_char);
  free(tmp_match);
}

void newStats(matchstring, fnd_qos_file, fnd_qos_rec, seconds, count)
char matchstring[];
int *fnd_qos_file;
int *fnd_qos_rec;
int *seconds;
int *count;
{
int mask;

  if (qosOn == FALSE)
    return;
  if (*fnd_qos_file == TRUE)
  {
    if (*fnd_qos_rec == TRUE)
      updateStats(matchstring, *seconds, *count);
    else
      addToStats(matchstring);
  }
  else
  {
    mask = umask(0);
    if ((qos_file = fopen(qosfilename, "w")) == (FILE *) NULL)
      (void) fprintf(stderr, "\nError creating qos (quality of service) file\n");
    else
      addToStats(matchstring);
    (void)umask(mask);
  }
}
#else
foo()
{
}
#endif QOS
#endif DOS
