/* ou.c - search for an org unit */

#ifndef lint
static char *rcsid = "$Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/ou.c,v 9.3 1993/03/19 22:55:47 isode Exp isode $";
#endif

/*
 * $Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/ou.c,v 9.3 1993/03/19 22:55:47 isode Exp isode $
 *
 *
 * $Log: ou.c,v $
 * Revision 9.3  1993/03/19  22:55:47  isode
 * Add QOS and DOS-DE code
 *
 * Revision 9.2  1992/12/15  07:05:26  awy
 * Update and fixes
 *
 * Revision 8.1  1991/09/13  14:36:41  isode
 * PARADISE Upgrade release
 *
 * Revision 8.0  91/07/17  13:18:47  isode
 * Release 7.0
 *
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */

#define ou_c
#ifdef DOS
#include <stdlib.h>
#include "proto-de.h"
#endif DOS
#include "messages.h"
#include <signal.h>
#ifdef USELDAP
#include <string.h>
#ifdef IC
#include <ldap/lber.h>
#include <ldap/ldap.h>
#else
#include <lber.h>
#include <ldap.h>
#endif /* IC */
#include "isomanifest.h"
#ifdef DOS
#include <msdos.h>
#else
#include <sys/time.h>
#endif DOS
#else
#include "quipu/util.h"
#include "quipu/read.h"
#include "quipu/list.h"
#include "quipu/ds_search.h"
#include "quipu/dua.h"
#endif USELDAP
#include "demanifest.h"
#include "namelist.h"
#include "destrings.h"

#ifdef USELDAP
extern LDAP * ldap_ld;
extern char * ldap_base;
extern int ldap_scope;
extern char ldap_filter[BUFSIZ];
extern char ** ldap_attrs;
extern char ldap_attrsonly;
extern int ldap_msgid;
extern int ldap_all;
extern struct timeval ldap_timeout;
extern LDAPMessage * ldap_res;
LDAPMessage * entry_dup();
#else
extern char filbuf[];
extern struct ds_list_arg larg;
extern struct ds_list_result lresult;

extern struct ds_search_arg sarg;
extern struct ds_search_result sresult;
extern struct DSError serror;
#endif USELDAP

extern int abandoned;
extern int highNumber;
extern int exactMatch;
extern int fuzzyMatching;
extern int gotFuzzyMatch;
extern int quipuMastersCo;
extern char exactString[];

struct namelist * ouatts;

#ifdef USELDAP
void fillMostOUListArgs();
void fillMostOUSearchArgs();
#else
struct ds_list_arg *fillMostOUListArgs();
struct ds_search_arg *fillMostOUSearchArgs();
#endif USELDAP

VFP explicitOU[] = {genExplicitFilter, NULLVFP};
VFP normalOU[] = {genFilter1, genFilter2, genFilter3, genFilter4, NULLVFP};

int
listOUs(parentstr, thisstr, listp)
char * parentstr, * thisstr;
struct namelist ** listp;
{
	clearProblemFlags();
	initAlarm();
	if (exactMatch == ORGUNIT)
	  return (readExactOU(exactString, listp));
        if (strcmp(thisstr, "*") == 0)
          return (listAllOUs(parentstr, listp));
        else
          return (listMatchingOUs(parentstr, thisstr, listp));
}

void
printListOUs(str, listp)
char * str;
struct namelist * listp;
{
struct namelist * x;
int i;
	if (listp == NULLLIST)
		if (strcmp(str, "*") == 0)
			pageprint(NOOUSFOUND);
		else
			pageprint(NOOUSMATCH, str);
	else
	{
		for (i =1, x = listp; x != NULLLIST; i++, x = x->next)
			printLastComponent(INDENTON, x->name, ORGUNIT, i);
		showAnyProblems(str);
	}
}

void
freeOUs(listpp)
struct namelist ** listpp;
{
struct namelist * x, * y;

	x = *listpp;
	while (x != NULLLIST)
	{
		if (x->name != NULLCP)
			free(x->name);
#ifdef USELDAP
		if (x->ats) ldap_msgfree(x->ats);
#else
		as_free(x->ats);
#endif USELDAP
		y = x->next;
		free((char *)x);
		x = y;
	}
	*listpp = NULLLIST;
}

void
freeOUListArgs()
{
#ifdef USELDAP
	freeLdapOpArgs();
#else
	dn_free(larg.lsa_object);
#endif USELDAP
}

void
freeOUSearchArgs()
{
#ifdef USELDAP
	freeLdapOpArgs();
#else
	dn_free(sarg.sra_baseobject);
	as_free(sarg.sra_eis.eis_select);
#endif USELDAP
}

#ifdef DOS
void
#else
int
#endif
powerSearchOUs(parentstr, thisstr, opp)
char * parentstr, * thisstr;
int * opp;
{
   clearProblemFlags();
#ifdef USELDAP
   fillMostOUSearchArgs(parentstr, LDAP_SCOPE_SUBTREE);
   if (strlen(thisstr) <= 3)
     genFilter1(thisstr, DE_ORGANISATIONAL_UNIT, 
     	DE_ORGANISATIONAL_UNIT_NAME); /* ou=foo */
   else
     genFilter3(thisstr, DE_ORGANISATIONAL_UNIT, 
     	DE_ORGANISATIONAL_UNIT_NAME); /* ou=*foo* */
   (void)de_asynSearch(opp); /* opp contains opno value */
   freeOUSearchArgs();
#else
   sarg = * fillMostOUSearchArgs(parentstr, SRA_WHOLESUBTREE);
   if (strlen(thisstr) <= 3)
     genFilter1(thisstr, DE_ORGANISATIONAL_UNIT, DE_ORGANISATIONAL_UNIT_NAME,
     	&sarg.sra_filter); /* ou=foo */
   else
     genFilter3(thisstr, DE_ORGANISATIONAL_UNIT, DE_ORGANISATIONAL_UNIT_NAME,
     	&sarg.sra_filter); /* ou=*foo* */
   (void)de_asynSearch(&sarg, &serror, opp); /* opp contains opno value */
   filter_free(sarg.sra_filter);
#endif USELDAP
   return;
}


int
listAllOUs(parentstr, listp)
char * parentstr;
struct namelist ** listp;
{
int ret;
	
	if (quipuMastersCo == FALSE)
	{
#ifdef USELDAP
		fillMostOUListArgs(parentstr);
#else
		larg = * fillMostOUListArgs(parentstr);
#endif USELDAP
		ret = reallyMakeListOUs(listp);
	}
	else
	{
#ifdef USELDAP
	        fillMostOUSearchArgs(parentstr, LDAP_SCOPE_ONELEVEL);	
	        genAllFilter(DE_ORGANISATIONAL_UNIT);
#else
	        sarg = * fillMostOUSearchArgs(parentstr, SRA_ONELEVEL);	
	        genAllFilter(DE_ORGANISATIONAL_UNIT, &sarg.sra_filter);
#endif USELDAP
	        ret = makeListOUs(listp);
	}
        if (ret != OK)
		logListSuccess(LIST_ERROR, "ou", 0);
        else
		logListSuccess(LIST_OK, "ou", listlen(*listp));
	if (quipuMastersCo == FALSE)
		freeOUListArgs();
	else
		freeOUSearchArgs();
	alarmCleanUp();
	return ret;
}

int
listMatchingOUs(parentstr, thisstr, listp)
char * parentstr, * thisstr;
struct namelist ** listp;
{
VFP * filtarray;
VFP filterfunc;
int filtnumber;
char rstr[BUFSIZ];

        if (index(thisstr, '*') != NULLCP) /* contains at least one asterisk */
	{
                filtarray = explicitOU;
		filtnumber = -1;
	}
        else
	{
                filtarray = normalOU;
		filtnumber = 0;
	}
	if (quipuMastersCo ==FALSE) /* try read first */
	{
#ifdef USELDAP
		(void)sprintf(rstr, "ou=%s, %s", thisstr, parentstr);
#else
		(void)sprintf(rstr, "%s@ou=%s", parentstr, thisstr);
#endif USELDAP
		if (readExactOrg(rstr, listp) == OK)
		{
			logReadSuccess(READ_OK, "ou");
			return OK;
		}
		else
			/* else try searches */
			logReadSuccess(READ_FAIL, "ou");
	}
#ifdef USELDAP
	fillMostOUSearchArgs(parentstr, LDAP_SCOPE_ONELEVEL);
#else
	sarg = * fillMostOUSearchArgs(parentstr, SRA_ONELEVEL);
#endif USELDAP
        while ((filterfunc = *filtarray++) != NULLVFP)
	{
		filtnumber++;
#ifdef USELDAP
                filterfunc(thisstr, DE_ORGANISATIONAL_UNIT,
			DE_ORGANISATIONAL_UNIT_NAME);
		if (strcmp(ldap_filter, "") == 0)
			continue;
#else
                filterfunc(thisstr, DE_ORGANISATIONAL_UNIT, 
			DE_ORGANISATIONAL_UNIT_NAME, &sarg.sra_filter);
		if (sarg.sra_filter == NULLFILTER)
			continue;
#endif USELDAP
                if (makeListOUs(listp) != OK)
		{
			freeOUSearchArgs();
			logSearchSuccess(SEARCH_ERROR, "ou", thisstr, filtnumber, 0);
			alarmCleanUp();
			return NOTOK;
		}
                if (*listp != NULLLIST)
		{
			freeOUSearchArgs();
			logSearchSuccess(SEARCH_OK, "ou", thisstr, filtnumber, listlen(*listp));
			alarmCleanUp();
                        return OK;
		}
	}
	logSearchSuccess(SEARCH_FAIL, "ou", thisstr, filtnumber, 0);

	/* nothing found by single level searches - let's try subtree searching */
        if (index(thisstr, '*') != NULLCP) /* contains at least one asterisk */
	{
                filtarray = explicitOU;
		filtnumber = -1;
	}
        else
	{
                filtarray = normalOU;
		filtnumber = 0;
	}
#ifdef USELDAP
	fillMostOUSearchArgs(parentstr, LDAP_SCOPE_SUBTREE);
#else
	sarg = * fillMostOUSearchArgs(parentstr, SRA_WHOLESUBTREE);
#endif USELDAP
        while ((filterfunc = *filtarray++) != NULLVFP)
	{
		filtnumber++;
#ifdef USELDAP
                filterfunc(thisstr, DE_ORGANISATIONAL_UNIT,
			DE_ORGANISATIONAL_UNIT_NAME);
#else
                filterfunc(thisstr, DE_ORGANISATIONAL_UNIT, 
			DE_ORGANISATIONAL_UNIT_NAME, &sarg.sra_filter);
#endif USELDAP
                if (makeListOUs(listp) != OK)
		{
			freeOUSearchArgs();
			alarmCleanUp();
			return NOTOK;
		}
                if (*listp != NULLLIST)
		{
			freeOUSearchArgs();
			logSearchSuccess(SEARCH_OK, "ou", thisstr, filtnumber, listlen(*listp));
			alarmCleanUp();
                        return OK;
		}
	}
	logSearchSuccess(SEARCH_FAIL, "ou", thisstr, filtnumber, 0);
	freeOUSearchArgs();
	alarmCleanUp();
	return OK;
}

int
readExactOU(oustr, olistp)
char * oustr;
struct namelist ** olistp;
{
int ret;

        ret = readOU(oustr, olistp);
        alarmCleanUp();
        return ret;
}

int
reallyMakeListOUs(olistp)
struct namelist ** olistp;
{
#ifdef USELDAP
LDAPMessage * enp;
#else
struct subordinate * x;
DN dn1, dn2;
#endif USELDAP
int retval;
char * cp;

	if (rebind() != OK)
		return NOTOK;
#ifdef USELDAP
	retval = de_list();
	/* something should happen here ??? */
#else
	retval = de_list(&larg, &serror, &lresult);
	if ((retval == DSE_INTR_ABANDONED) &&
	    (serror.dse_type == DSE_ABANDONED))
	       abandoned = TRUE;
#endif USELDAP

	/* setProblemFlags(sresult); */
	highNumber = 0;
#ifdef USELDAP
	if (ldap_count_entries(ldap_ld, ldap_res) > 0)
		for (enp = ldap_first_entry(ldap_ld, ldap_res); enp != NULL;
				enp = ldap_next_entry(ldap_ld, enp))
	{
		/* only add locs to the list */
		cp = ldap_get_dn(ldap_ld, enp);
		if (strncmp(cp, DE_ORGANISATIONAL_UNIT_NAME,
				strlen(DE_ORGANISATIONAL_UNIT_NAME)) == 0)
		{
			*olistp = list_alloc();
			(*olistp)->name = cp;
			(*olistp)->ats = NULLMSG;
			olistp = &(*olistp)->next;
			highNumber++;
		}
		else free(cp);
	}
#else
	for (x = lresult.lsr_subordinates; x != (struct subordinate *) NULL;
	                                    x = x->sub_next)
	{
		/* only add ous to the list */
		cp = strdup(attr2name(x->sub_rdn->rdn_at, OIDPART));
		if (strcmp(cp, DE_ORGANISATIONAL_UNIT_NAME) == 0)
		{
			*olistp = list_alloc();
			dn1 = dn_cpy(larg.lsa_object);
			dn2 = dn_comp_new(x->sub_rdn);
			dn_append(dn1, dn2);
			(*olistp)->name = dn2pstr(dn1);
			(*olistp)->ats = NULLATTR;
			olistp = &(*olistp)->next;
			highNumber++;
			
		}
		free(cp);
	}
#endif USELDAP
	*olistp = NULLLIST;
#ifndef USELDAP
	/* free something */
	dn_free (lresult.lsr_object);
	/* free something else */
#endif USELDAP
	return OK;
}



int
listExactOUs(objectstr, listp)
char * objectstr;
struct namelist ** listp;
{
int ret;

#ifdef USELDAP
        fillMostOUSearchArgs(objectstr, LDAP_SCOPE_BASE);
        genAllFilter(DE_ORGANISATIONAL_UNIT);
#else
        sarg = * fillMostOUSearchArgs(objectstr, SRA_BASEOBJECT);
        genAllFilter(DE_ORGANISATIONAL_UNIT, &sarg.sra_filter);
#endif USELDAP
        ret = makeListOUs(listp);
	freeOUSearchArgs();
	alarmCleanUp();
	return ret;
}

int
makeListOUs(listp)
struct namelist ** listp;
{
#ifdef USELDAP
LDAPMessage * enp;
#else
entrystruct * x;
#endif USELDAP
int retval;

	if (rebind() != OK)
		return NOTOK;
#ifdef USELDAP
	retval = de_search();
#else
	retval = de_search(&sarg, &serror, &sresult);
        if ((retval == DSE_INTR_ABANDONED) &&
	    (serror.dse_type == DSE_ABANDONED))
		abandoned = TRUE;
#endif USELDAP
	if (retval != OK)
		return NOTOK;
#ifdef USELDAP
	setProblemFlags(ldap_ld->ld_errno);
#else
	correlate_search_results (&sresult);

	setProblemFlags(sresult);
#endif USELDAP

	highNumber = 0;
#ifdef USELDAP
	if (ldap_count_entries(ldap_ld, ldap_res) > 0)
		for (enp = ldap_first_entry(ldap_ld, ldap_res); enp != NULL;
				enp = ldap_next_entry(ldap_ld, enp))
	{
		*listp = list_alloc();
		(*listp)->name = ldap_get_dn(ldap_ld, enp);
		(*listp)->ats = entry_dup(enp);
		listp = &(*listp)->next;
		highNumber++;
	}
#else
	for (x = sresult.CSR_entries; x != NULLENTRYINFO; x = x->ent_next) {
		*listp = list_alloc();
		(*listp)->name = dn2pstr(x->ent_dn);
                (*listp)->ats = as_cpy(x->ent_attr);
		listp = &(*listp)->next;
		highNumber++;
	}
#endif USELDAP
	*listp = NULLLIST;
#ifndef USELDAP
	entryinfo_free(sresult.CSR_entries,0);
	dn_free (sresult.CSR_object);
	crefs_free (sresult.CSR_cr);
	filter_free(sarg.sra_filter);
#endif USELDAP
	return OK;
}

int
readOU(ostr, olistp)
char * ostr;
struct namelist ** olistp;
{
#ifdef USELDAP
LDAPMessage * enp;
#else
static struct ds_read_arg rarg;
static struct ds_read_result rresult;
static struct DSError rerror;
static CommonArgs sca = default_common_args;
Attr_Sequence * atl;
AttributeType at;
struct namelist * x;
#endif USELDAP
int retval;

	if (rebind() != OK)
		return NOTOK;
#ifdef USELDAP
	ldap_base = removeLastRDN(ostr);
	ldap_scope = LDAP_SCOPE_ONELEVEL;
	ldap_attrs = makeAllAttrs(ouatts);
	ldap_attrsonly = 0;
	ldap_all = 1;
	ldap_timeout.tv_sec = 2;
	ldap_timeout.tv_usec = 0;
	(void)sprintf(ldap_filter, "(%s)", lastRDN(ostr));
	retval = de_read();
#else
	rarg.rda_common =sca; /* struct copy */
	rarg.rda_common.ca_servicecontrol.svc_timelimit = SVC_NOTIMELIMIT;
	rarg.rda_common.ca_servicecontrol.svc_sizelimit= SVC_NOSIZELIMIT;
	rarg.rda_object = str2dn(ostr);
	/* specify attributes of interest */
	rarg.rda_eis.eis_allattributes = FALSE;
	atl = &(rarg.rda_eis.eis_select);
	for (x = ouatts; x != NULLLIST; x = x->next)
	{
		if ((at = str2AttrT(x->name)) == NULLAttrT)
			continue;
		*atl = as_comp_alloc();
		(*atl)->attr_type = at;
		(*atl)->attr_value = NULLAV;
		atl = &(*atl)->attr_link;
	}
	*atl = NULLATTR;
	rarg.rda_eis.eis_infotypes = EIS_ATTRIBUTESANDVALUES;
	retval = de_read(&rarg, &rerror, &rresult);
	if ((retval == DSE_INTR_ABANDONED) &&
            (rerror.dse_type == DSE_ABANDONED))
                abandoned = TRUE;
#endif USELDAP
	if (retval != OK)
	        return NOTOK;
	/* setProblemFlags(sresult); */
	highNumber = 1;	
	*olistp = list_alloc();
#ifdef USELDAP
	if (ldap_count_entries(ldap_ld, ldap_res) > 0) {
		enp = ldap_first_entry(ldap_ld, ldap_res);
		(*olistp)->name = ldap_get_dn(ldap_ld, enp);
		(*olistp)->ats = entry_dup(enp);
	}
	else
		return NOTOK;
#else
	(*olistp)->name = dn2pstr(rresult.rdr_entry.ent_dn);
	(*olistp)->ats = as_cpy(rresult.rdr_entry.ent_attr);
#endif USELDAP
	(*olistp)->next = NULLLIST;
	return retval;
}

#ifdef USELDAP
void
fillMostOUListArgs(str)
char * str;
{
	ldap_base = copy_string(str);
	ldap_scope = LDAP_SCOPE_ONELEVEL;
	ldap_attrs = (char **) NULL;
	ldap_attrsonly = 1;
	ldap_all = 1;
	ldap_timeout.tv_sec = 2;
	ldap_timeout.tv_usec = 0;
	(void)sprintf(ldap_filter, "(objectclass=organizationalUnit)");
}
#else
struct ds_list_arg *
fillMostOUListArgs(str)
char * str;
{
static struct ds_list_arg arg;
static CommonArgs sca = default_common_args;

	arg.lsa_common =sca; /* struct copy */
	arg.lsa_common.ca_servicecontrol.svc_timelimit = SVC_NOTIMELIMIT;
	arg.lsa_common.ca_servicecontrol.svc_sizelimit= SVC_NOSIZELIMIT;

	arg.lsa_object = str2dn(str);
	return (&arg);
}
#endif USELDAP



#ifdef USELDAP
void
fillMostOUSearchArgs(parentstr, searchdepth)
char * parentstr;
int searchdepth;
{
	ldap_base = copy_string(parentstr);
	ldap_scope = searchdepth;
	ldap_attrs = makeAllAttrs(ouatts);
	ldap_attrsonly = 0;
	ldap_all = 1;
	ldap_timeout.tv_sec = 2;
	ldap_timeout.tv_usec = 0;
}
#else
struct ds_search_arg *
fillMostOUSearchArgs(parentstr, searchdepth)
char * parentstr;
int searchdepth;
{
static struct ds_search_arg arg;
Attr_Sequence * atl;
AttributeType at;
struct namelist * x;
static CommonArgs sca = default_common_args;

	arg.sra_common = sca; /* struct copy */
        arg.sra_common.ca_servicecontrol.svc_timelimit = SVC_NOTIMELIMIT;
        arg.sra_common.ca_servicecontrol.svc_sizelimit= SVC_NOSIZELIMIT;

	arg.sra_subset = searchdepth;
	arg.sra_baseobject = str2dn(parentstr);
	arg.sra_searchaliases = TRUE;
	/* specify attributes of interest */
	arg.sra_eis.eis_allattributes = FALSE;
	atl = &(arg.sra_eis.eis_select);
        for (x = ouatts; x != NULLLIST; x = x->next)
        {
		if ((at = str2AttrT(x->name)) == NULLAttrT)
			continue;
                *atl = as_comp_alloc();
                (*atl)->attr_type = at;
		(*atl)->attr_value = NULLAV;
                atl = &(*atl)->attr_link;
        }
        *atl = NULLATTR;
	arg.sra_eis.eis_infotypes = EIS_ATTRIBUTESANDVALUES;
	return (&arg);
}
#endif USELDAP
