/* people.c - search for a person */

#ifndef lint
static char *rcsid = "$Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/people.c,v 9.3 1993/03/19 22:55:55 isode Exp isode $";
#endif

/*
 * $Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/people.c,v 9.3 1993/03/19 22:55:55 isode Exp isode $
 *
 *
 * $Log: people.c,v $
 * Revision 9.3  1993/03/19  22:55:55  isode
 * Add QOS and DOS-DE code
 *
 * Revision 9.2  1992/12/15  07:05:26  awy
 * Update and fixes
 *
 * Revision 8.1  1991/09/13  14:36:41  isode
 * PARADISE Upgrade release
 *
 * Revision 8.0  91/07/17  13:18:48  isode
 * Release 7.0
 *
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */

#define people_c
#ifdef DOS
#include <stdlib.h>
#include "proto-de.h"
#endif
#include "messages.h"
#include <signal.h>
#ifdef USELDAP
#include <string.h>
#ifdef IC
#include <ldap/lber.h>
#include <ldap/ldap.h>
#else
#include <lber.h>
#include <ldap.h>
#endif /* IC */
#include "isomanifest.h"
#ifdef DOS
#include <msdos.h>
#else
#include <sys/time.h>
#endif DOS
#else
#include "quipu/util.h"
#include "quipu/ds_search.h"
#include "quipu/read.h"
#include "quipu/dua.h"
#endif USELDAP
#include "demanifest.h"
#include "namelist.h"
#include "destrings.h"
#include "asyn.h"

#ifdef USELDAP
extern LDAP * ldap_ld;
extern char * ldap_base;
extern int ldap_scope;
extern char ldap_filter[BUFSIZ];
extern char ** ldap_attrs;
extern char ldap_attrsonly;
extern int ldap_msgid;
extern int ldap_all;
extern struct timeval ldap_timeout;
extern LDAPMessage * ldap_res;
LDAPMessage * entry_dup();
#else
extern char filbuf[LINESIZE];
extern struct ds_search_arg sarg;
extern struct ds_search_result sresult;
extern struct DSError serror;
#endif USELDAP

extern char mode;
extern int abandoned;
extern int accessrightproblem;
extern int highNumber;
extern int exactMatch;
extern int fuzzyMatching;
extern int gotFuzzyMatch;
extern char exactString[];

/* PRR stands fpr people, rooms and roles */

struct namelist * prratts;

#ifdef USELDAP
void fillMostPRRSearchArgs();
#else
struct ds_search_arg *fillMostPRRSearchArgs();
Filter get_filter();
#endif USELDAP

void makeExplicitPRRFilter();
void prrFilter1(), prrFilter2(), prrFilter3(), prrFilter4();
void exactSurname(), makeAllPFilter();

VFP explicitPRR[] = {makeExplicitPRRFilter, NULLVFP};
VFP normalPRR[] = {prrFilter1, prrFilter2, prrFilter3, prrFilter4, NULLVFP};
/*VFP normalPRR[] = {prrFilter1, prrFilter3, NULLVFP};*/

int
listPRRs(parentstr, thisstr, listp)
char * parentstr, * thisstr;
struct namelist ** listp;
{
	clearProblemFlags();
	initAlarm();	
	if (exactMatch == PERSON)
		return(readExactPRR(exactString, listp));
        if (strcmp(thisstr, "*") == 0)
          return (listAllPRRs(parentstr, listp));
        else
          return (listMatchingPRRs(parentstr, thisstr, listp));
}
#ifdef CRAP
void
hackprintListPRRs(str, listp, searchparent, pdet, fromNumber)
char * str;
struct namelist * listp;
int searchparent, pdet, fromNumber;
{
struct namelist * x;
char * savestr;
static char lastsavedcomp[LINESIZE], saveOrgName[LINESIZE];
int i;

	saveOrgName[0] = '\0';
	if (listp == NULLLIST)
		if (strcmp(str, "*") == 0)
			pageprint(NOPEOPLEFOUND);
		else
			pageprint(NOPEOPLEMATCH);
	else
	{
		for (i = fromNumber + 1, x = listp; x != NULLLIST; i++, x = x->next)
		{
			if (strcmp(orgNameFromDN(x->name, 0), saveOrgName) != 0)
			{
			  (void)strcpy(saveOrgName, orgNameFromDN(x->name, 0));
			  printLastComponent(INDENTON, saveOrgName, ORG, 0);
			}
			/* if searching subtree under org (as opposed to an
			   org unit), print ou if there is one */
			if (searchparent == ORG)
			{
				savestr = removeLastRDN(x->name);
#ifdef USELDAP
				if (index(savestr, ',') != rindex(savestr, ','))
				{
				    if (strncmp(savestr, 
				          SHORT_OU, strlen(SHORT_OU)) == 0)
#else
				if (index(savestr, '@') != rindex(savestr, '@'))
				{
				    if (strncmp((rindex(savestr, '@') + 1), 
				          SHORT_OU, strlen(SHORT_OU)) == 0)
#endif USELDAP
					if (strcmp(lastsavedcomp, savestr) != 0)
					{
						printLastComponent(INDENTON, savestr, ORGUNIT, 0);
						(void) strcpy(lastsavedcomp, savestr);
					}
				}
				free (savestr);
			}
			if (pdet)
			{
				printLastComponent(INDENTON, x->name, PERSON,
 							pdet ? 0 : i);
				printDetails(PERSON, x);
			}
			else
				printPersonOneLiner(x, i);
		}
		/* showAnyProblems(str); don't think we want this */
	}
	lastsavedcomp[0] = '\0';
}

void
printListPRRs(str, listp, searchparent, pdet, fromNumber)
char * str;
struct namelist * listp;
int searchparent, pdet, fromNumber;
{
struct namelist * x;
char * savestr;
static char lastsavedcomp[LINESIZE];
int i;

	if (listp == NULLLIST)
		if (strcmp(str, "*") == 0)
			pageprint(NOPEOPLEFOUND);
		else
			pageprint(NOPEOPLEMATCH);
	else
	{
		for (i = fromNumber + 1, x = listp; x != NULLLIST; i++, x = x->next)
		{
			/* if searching subtree under org (as opposed to an
			   org unit), print ou if there is one */
			if (searchparent == ORG)
			{
				savestr = removeLastRDN(x->name);
#ifdef USELDAP
                                if (index(savestr, ',') != rindex(savestr, ','))
                                {
                                    if (strncmp(savestr,
                                          SHORT_OU, strlen(SHORT_OU)) == 0)
#else
				if (index(savestr, '@') != rindex(savestr, '@'))
				{
				    if (strncmp((rindex(savestr, '@') + 1), 
				          SHORT_OU, strlen(SHORT_OU)) == 0)
#endif USELDAP
					if (strcmp(lastsavedcomp, savestr) != 0)
					{
						printLastComponent(INDENTON, savestr, ORGUNIT, 0);
						(void) strcpy(lastsavedcomp, savestr);
					}
				}
				free (savestr);
			}
			if (pdet)
			{
				printLastComponent(INDENTON, x->name, PERSON,
 							pdet ? 0 : i);
				printDetails(PERSON, x);
			}
			else
				printPersonOneLiner(x, i);
		}
		showAnyProblems(str);
	}
	lastsavedcomp[0] = '\0';
}
#endif CRAP

void
printListPRRs(str, listp, searchparent, pdet, fromNumber)
char * str;
struct namelist * listp;
int searchparent, pdet, fromNumber;
{
struct namelist * x;
char * savestr;
static char lastsavedcomp[LINESIZE], saveOrgName[LINESIZE];
int i;

	saveOrgName[0] = '\0';
	if (listp == NULLLIST)
		if (strcmp(str, "*") == 0)
			pageprint(NOPEOPLEFOUND);
		else
			pageprint(NOPEOPLEMATCH);
	else
	{
		for (i = fromNumber + 1, x = listp; x != NULLLIST; i++, x = x->next)
		{
		 	if (mode == POWERLETTER)
			{
			  if (strcmp(orgNameFromDN(x->name, 0), saveOrgName) != 0)
			  {
			    (void)strcpy(saveOrgName, orgNameFromDN(x->name, 0));
			    printLastComponent(INDENTON, saveOrgName, ORG, 0);
			  }
			}
			/* if searching subtree under org (as opposed to an
			   org unit), print ou if there is one */
			if (searchparent == ORG)
			{
				savestr = removeLastRDN(x->name);
#ifdef USELDAP
                                if (index(savestr, ',') != rindex(savestr, ','))
                                {
                                    if (strncmp(savestr,
                                          SHORT_OU, strlen(SHORT_OU)) == 0)
#else
				if (index(savestr, '@') != rindex(savestr, '@'))
				{
				    if (strncmp((rindex(savestr, '@') + 1), 
				          SHORT_OU, strlen(SHORT_OU)) == 0)
#endif USELDAP
					if (strcmp(lastsavedcomp, savestr) != 0)
					{
						printLastComponent(INDENTON, savestr, ORGUNIT, 0);
						(void) strcpy(lastsavedcomp, savestr);
					}
				}
				free (savestr);
			}
			if (pdet)
			{
				printLastComponent(INDENTON, x->name, PERSON,
 							pdet ? 0 : i);
				printDetails(PERSON, x);
			}
			else
				printPersonOneLiner(x, i);
		}
		if (mode == SIMPLELETTER)
			showAnyProblems(str);
	}
	lastsavedcomp[0] = '\0';
}


void
freePRRs(listpp)
struct namelist ** listpp;
{
struct namelist * w, * x;

	w = *listpp;
	while (w != NULLLIST)
	{
		if (w->name != NULLCP)
			free(w->name);
#ifdef USELDAP
		if (w->ats) ldap_msgfree(w->ats);
#else
		as_free(w->ats);
#endif USELDAP
		x = w->next;
		free((char *)w);
		w = x;
	}
	*listpp = NULLLIST;
}

void
freePRRSearchArgs()
{
#ifdef USELDAP
	freeLdapOpArgs();
#else
	dn_free(sarg.sra_baseobject);
	as_free(sarg.sra_eis.eis_select);
#endif USELDAP
}

int
listAllPRRs(parentstr, listp)
char * parentstr;
struct namelist ** listp;
{
int ret;
	
#ifdef USELDAP
        fillMostPRRSearchArgs(parentstr, LDAP_SCOPE_SUBTREE);
        makeAllPRRFilter();
#else
        sarg = * fillMostPRRSearchArgs(parentstr, SRA_WHOLESUBTREE);
        makeAllPRRFilter(&sarg.sra_filter);
#endif USELDAP
        ret = makeListPRRs(listp, parentstr);
	if (ret != OK)
		logListSuccess(LIST_ERROR, "prr", 0);
	else
		logListSuccess(LIST_OK, "prr", listlen(*listp));
	freePRRSearchArgs();
	alarmCleanUp();
	return ret;
}

#ifdef DOS
void
#else
int
#endif DOS
powerSearchPeople(parentstr, thisstr, opp)
char * parentstr, * thisstr;
int * opp;
{
   clearProblemFlags();
#ifdef USELDAP
   fillMostPRRSearchArgs(parentstr, LDAP_SCOPE_SUBTREE);
   if (strcmp(thisstr, "*") == 0)
     makeAllPFilter(); /* sn=* */
   else if (index(thisstr, '*') != 0)
     makeExplicitPRRFilter(thisstr);
   else if (index(thisstr, ' ') == 0)
     exactSurname(thisstr); /* sn=foo */
   else
     prrFilter2(thisstr); /* cn=f*bar */
   (void)de_asynSearch(opp); /* opp contains opno value */
   freePRRSearchArgs();
#else
   sarg = * fillMostPRRSearchArgs(parentstr, SRA_WHOLESUBTREE);
   if (strcmp(thisstr, "*") == 0)
     makeAllPFilter(&sarg.sra_filter); /* sn=* */
   else if (index(thisstr, '*') != 0)
     makeExplicitPRRFilter(thisstr, &sarg.sra_filter);
   else if (index(thisstr, ' ') == 0)
     exactSurname(thisstr, &sarg.sra_filter); /* sn=foo */
   else
     prrFilter2(thisstr, &sarg.sra_filter); /* cn=f*bar */
   (void)de_asynSearch(&sarg, &serror, opp); /* opp contains opno value */
   filter_free(sarg.sra_filter);
#endif USELDAP
   return;
}

int
listMatchingPRRs(parentstr, thisstr, listp)
char * parentstr, * thisstr;
struct namelist ** listp;
{
VFP * filtarray;
VFP filterfunc;
int filtnumber;

        if (index(thisstr, '*') != NULLCP) /* contains at least one asterisk */
	{
                filtarray = explicitPRR;
		filtnumber = -1;
	}
        else
	{
                filtarray = normalPRR;
		filtnumber = 0;
	}
#ifdef USELDAP
	fillMostPRRSearchArgs(parentstr, LDAP_SCOPE_SUBTREE);
#else
	sarg = * fillMostPRRSearchArgs(parentstr, SRA_WHOLESUBTREE);
#endif USELDAP
        while ((filterfunc = *filtarray++) != NULLVFP)
	{
		filtnumber++;
#ifdef USELDAP
                filterfunc(thisstr);
		if (strcmp(ldap_filter, "") == 0)
			continue;
#else
                filterfunc(thisstr, &sarg.sra_filter);
		if (sarg.sra_filter == NULLFILTER)
			continue;
#endif USELDAP
                if (makeListPRRs(listp, parentstr) != OK)
		{
			freePRRSearchArgs();
			logSearchSuccess(SEARCH_ERROR, "prr", thisstr, filtnumber, 0);
			alarmCleanUp();
		        return NOTOK;
		}
                if (*listp != NULLLIST)
                        break;
	}
	if (*listp != NULLLIST)
		logSearchSuccess(SEARCH_OK, "prr", thisstr, filtnumber, listlen(*listp));
	else
		logSearchSuccess(SEARCH_FAIL, "prr", thisstr, filtnumber, 0);
	freePRRSearchArgs();
	alarmCleanUp();
	return OK;
}

int
readExactPRR(objectstr, listp)
char * objectstr;
struct namelist ** listp;
{
int ret;

        ret = readPerson(objectstr, listp);
	alarmCleanUp();
	return ret;
}

/* needs combining with makeListPRRs */
int
makeListForOneOrg(opid)
int * opid;
{
int ret;
struct namelist ** listp;
struct opsPending * oplp;
#ifdef USELDAP
LDAPMessage * enp;
#else
entrystruct * x;
#endif USELDAP
char *cp, *cp2;

#ifdef USELDAP
  ret = waitSearchResponse(opid);
#else
  ret = waitSearchResponse(&serror, &sresult, opid);
#endif USELDAP
  if (ret != OK)
    return ret;
  oplp = findOp(*opid);
  listp = & oplp->lp;
#ifdef USELDAP
  /* we want to build the list so that any people with no ou
   come first */
  if (ldap_count_entries(ldap_ld, ldap_res) > 0)
    for (enp = ldap_first_entry(ldap_ld, ldap_res); enp != NULL;
        enp = ldap_next_entry(ldap_ld, enp))
  {
    cp = ldap_get_dn(ldap_ld, enp);
    cp2 = removeLastRDN(cp);
    if (strncmp(lastRDN(cp2), SHORT_OU, strlen(SHORT_OU)) != 0)
    {
      *listp = list_alloc();
      (*listp)->name = cp;
      (*listp)->ats = entry_dup(enp);
      listp = &(*listp)->next;
    }
    else
      free(cp);
    free(cp2);
  }
  if (ldap_count_entries(ldap_ld, ldap_res) > 0)
    for (enp = ldap_first_entry(ldap_ld, ldap_res); enp != NULL;
        enp = ldap_next_entry(ldap_ld, enp))
  {
    cp = ldap_get_dn(ldap_ld, enp);
    cp2 = removeLastRDN(cp);
    if (strncmp(lastRDN(cp2), SHORT_OU, strlen(SHORT_OU)) == 0)
    {
      *listp = list_alloc();
      (*listp)->name = cp;
      (*listp)->ats = entry_dup(enp);
      listp = &(*listp)->next;
    }
    else
      free(cp);
    free(cp2);
  }
#else
  correlate_search_results (&sresult);
  /* we want to build the list so that any people with no ou
   come first */
  for (x = sresult.CSR_entries; x != NULLENTRYINFO; x = x->ent_next)
  {
     cp = dn2pstr(x->ent_dn);
     cp2 = removeLastRDN(cp);
     if (strncmp(lastRDN(cp2), SHORT_OU, strlen(SHORT_OU)) != 0)
     {
       *listp = list_alloc();
       (*listp)->name = cp;
       (*listp)->ats = as_cpy(x->ent_attr);
       listp = &(*listp)->next;
     }
     else
       free(cp);
     free(cp2);
  }
  for (x = sresult.CSR_entries; x != NULLENTRYINFO; x = x->ent_next)
  {
    cp = dn2pstr(x->ent_dn);
    cp2 = removeLastRDN(cp);
    if (strncmp(lastRDN(cp2), SHORT_OU, strlen(SHORT_OU)) == 0)
    {
      *listp = list_alloc();
      (*listp)->name = cp;
      (*listp)->ats = as_cpy(x->ent_attr);
      listp = &(*listp)->next;
    }
    else
      free(cp);
    free(cp2);
  }
#endif USELDAP
  *listp = NULLLIST;
#ifndef USELDAP
  entryinfo_free(sresult.CSR_entries,0);
  dn_free (sresult.CSR_object);
  crefs_free (sresult.CSR_cr);
#endif USELDAP
  return OK;
}

int
makeListPRRs(listp, parentstr)
struct namelist ** listp;
char * parentstr;
{
#ifdef USELDAP
LDAPMessage * enp;
#else
entrystruct * x;
#endif USELDAP
int retval;
char *cp, *cp2;

	if (rebind() != OK)
		return NOTOK;
#ifdef USELDAP
	retval = de_search();
#else
	retval = de_search(&sarg, &serror, &sresult);
	if (retval == DSE_INTR_ABANDONED) 
	  if (serror.dse_type == DSE_ABANDONED)
		abandoned = TRUE;
	  else if (serror.dse_type == DSE_SECURITYERROR)
	        accessrightproblem = TRUE;
#endif USELDAP
	if (retval != OK)
		return NOTOK;
#ifdef USELDAP
	setProblemFlags(ldap_ld->ld_errno);
#else
	correlate_search_results (&sresult);

	setProblemFlags(sresult);
#endif USELDAP

	highNumber = 0;
	if (strncmp(lastRDN(parentstr), SHORT_OU, strlen(SHORT_OU)) != 0)
	{
		/* we want to build the list so that any people with no ou 
		   come first */
#ifdef USELDAP
		if (ldap_count_entries(ldap_ld, ldap_res) > 0)
			for (enp = ldap_first_entry(ldap_ld, ldap_res);
				enp != NULL;enp = ldap_next_entry(ldap_ld, enp))
		{
			cp = ldap_get_dn(ldap_ld, enp);
			cp2 = removeLastRDN(cp);
			if (strncmp(lastRDN(cp2), SHORT_OU, strlen(SHORT_OU)) != 0)
			{
				*listp = list_alloc();
				(*listp)->name = cp;
				(*listp)->ats = entry_dup(enp);
				listp = &(*listp)->next;
				highNumber++;
			}
			else
				free(cp);
			free(cp2);
		}
		if (ldap_count_entries(ldap_ld, ldap_res) > 0)
			for (enp = ldap_first_entry(ldap_ld, ldap_res);
				enp != NULL;enp = ldap_next_entry(ldap_ld, enp))
		{
			cp = ldap_get_dn(ldap_ld, enp);
			cp2 = removeLastRDN(cp);
			if (strncmp(lastRDN(cp2), SHORT_OU, strlen(SHORT_OU)) == 0)
			{
				*listp = list_alloc();
				(*listp)->name = cp;
				(*listp)->ats = entry_dup(enp);
				listp = &(*listp)->next;
				highNumber++;
			}
			else
				free(cp);
			free(cp2);
		}
#else
		for (x = sresult.CSR_entries; x != NULLENTRYINFO; x = x->ent_next)
		{
			cp = dn2pstr(x->ent_dn);
			cp2 = removeLastRDN(cp);
			if (strncmp(lastRDN(cp2), SHORT_OU, strlen(SHORT_OU)) != 0)
			{
				*listp = list_alloc();
				(*listp)->name = cp;
				(*listp)->ats = as_cpy(x->ent_attr);
				listp = &(*listp)->next;
				highNumber++;
			}
			else
				free(cp);
			free(cp2);
		}
		for (x = sresult.CSR_entries; x != NULLENTRYINFO; x = x->ent_next)
		{
			cp = dn2pstr(x->ent_dn);
			cp2 = removeLastRDN(cp);
			if (strncmp(lastRDN(cp2), SHORT_OU, strlen(SHORT_OU)) == 0)
			{
				*listp = list_alloc();
				(*listp)->name = cp;
				(*listp)->ats = as_cpy(x->ent_attr);
				listp = &(*listp)->next;
				highNumber++;
			}
			else
				free(cp);
			free(cp2);
		}
#endif USELDAP
	}
	else
	{
#ifdef USELDAP
		if (ldap_count_entries(ldap_ld, ldap_res) > 0)
			for (enp = ldap_first_entry(ldap_ld, ldap_res);
				enp != NULL;enp = ldap_next_entry(ldap_ld, enp))
		{
			*listp = list_alloc();
			(*listp)->name = ldap_get_dn(ldap_ld, enp);
			(*listp)->ats = entry_dup(enp);
			listp = &(*listp)->next;
			highNumber++;
		}
#else
		for (x = sresult.CSR_entries; x != NULLENTRYINFO; x = x->ent_next)
		{
			*listp = list_alloc();
			(*listp)->name = dn2pstr(x->ent_dn);
			(*listp)->ats = as_cpy(x->ent_attr);
			listp = &(*listp)->next;
			highNumber++;
		}
#endif USELDAP
	}
	*listp = NULLLIST;
#ifndef USELDAP
	entryinfo_free(sresult.CSR_entries,0);
	dn_free (sresult.CSR_object);
	crefs_free (sresult.CSR_cr);
	filter_free(sarg.sra_filter);
#endif USELDAP
        return OK;
}

int
readPerson(pstr, plistp)
char * pstr;
struct namelist ** plistp;
{
#ifdef USELDAP
LDAPMessage * enp;
#else
static struct ds_read_arg rarg;
static struct ds_read_result rresult;
static struct DSError rerror;
static CommonArgs sca = default_common_args;
Attr_Sequence * atl;
AttributeType at;
struct namelist * x;
#endif USELDAP
int retval;

	if (rebind() != OK)
		return NOTOK;
#ifdef USELDAP
	ldap_base = removeLastRDN(pstr);
	ldap_scope = LDAP_SCOPE_ONELEVEL;
	ldap_attrs = makeAllAttrs(prratts);
	ldap_attrsonly = 0;
	ldap_all = 1;
	ldap_timeout.tv_sec = 2;
	ldap_timeout.tv_usec = 0;
	(void)sprintf(ldap_filter, "(%s)", lastRDN(pstr));
	retval = de_read();
#else
	rarg.rda_common =sca; /* struct copy */
	rarg.rda_common.ca_servicecontrol.svc_timelimit = SVC_NOTIMELIMIT;
	rarg.rda_common.ca_servicecontrol.svc_sizelimit= SVC_NOSIZELIMIT;
	rarg.rda_object = str2dn(pstr);
	/* specify attributes of interest */
	rarg.rda_eis.eis_allattributes = FALSE;
	atl = &(rarg.rda_eis.eis_select);
	for (x = prratts; x != NULLLIST; x = x->next)
	{
		if ((at = str2AttrT(x->name)) == NULLAttrT)
			continue;
		*atl = as_comp_alloc();
		(*atl)->attr_type = at;
		(*atl)->attr_value = NULLAV;
		atl = &(*atl)->attr_link;
	}
	*atl = NULLATTR;
	rarg.rda_eis.eis_infotypes = EIS_ATTRIBUTESANDVALUES;
	retval = de_read(&rarg, &rerror, &rresult);
	if ((retval == DSE_INTR_ABANDONED) &&
            (rerror.dse_type == DSE_ABANDONED))
                abandoned = TRUE;
#endif USELDAP
	if (retval != OK)
	        return NOTOK;
	/* setProblemFlags(sresult); */
	highNumber = 1;	
	*plistp = list_alloc();
#ifdef USELDAP
	if (ldap_count_entries(ldap_ld, ldap_res) > 0) {
		enp = ldap_first_entry(ldap_ld, ldap_res);
		(*plistp)->name = ldap_get_dn(ldap_ld, enp);
		(*plistp)->ats = entry_dup(enp);
	}
	else
		return NOTOK;
#else
	(*plistp)->name = dn2pstr(rresult.rdr_entry.ent_dn);
	(*plistp)->ats = as_cpy(rresult.rdr_entry.ent_attr);
#endif USELDAP
	(*plistp)->next = NULLLIST;
	return retval;
}

#ifdef USELDAP
void
fillMostPRRSearchArgs(parentstr, searchdepth)
char * parentstr;
int searchdepth;
{
	ldap_base = copy_string(parentstr);
	ldap_scope = searchdepth;
	ldap_attrs = makeAllAttrs(prratts);
	ldap_attrsonly = 0;
	ldap_all = 1;
	ldap_timeout.tv_sec = 2;
	ldap_timeout.tv_usec = 0;
}
#else
struct ds_search_arg *
fillMostPRRSearchArgs(parentstr, searchdepth)
char * parentstr;
int searchdepth;
{
static struct ds_search_arg arg;
Attr_Sequence * atl;
AttributeType at;
struct namelist * x;
static CommonArgs sca = default_common_args;

	arg.sra_common = sca; /* struct copy */
        arg.sra_common.ca_servicecontrol.svc_timelimit = SVC_NOTIMELIMIT;
        arg.sra_common.ca_servicecontrol.svc_sizelimit= SVC_NOSIZELIMIT;

	arg.sra_subset = searchdepth;
	arg.sra_baseobject = str2dn(parentstr);
	arg.sra_searchaliases = TRUE;
	/* specify attributes of interest */
	arg.sra_eis.eis_allattributes = FALSE;
	atl = &(arg.sra_eis.eis_select);
        for (x = prratts; x != NULLLIST; x = x->next)
        {
		if ((at = str2AttrT(x->name)) == NULLAttrT)
			continue;
                *atl = as_comp_alloc();
                (*atl)->attr_type = at;
		(*atl)->attr_value = NULLAV;
                atl = &(*atl)->attr_link;
	}
        *atl = NULLATTR;
	arg.sra_eis.eis_infotypes = EIS_ATTRIBUTESANDVALUES;
	return (&arg);
}
#endif USELDAP

#ifdef USELDAP
#ifdef DOS
void
#endif DOS
makeAllPRRFilter()
{
	gotFuzzyMatch = FALSE;
        (void)strcpy(ldap_filter, "(|(sn=*)(objectclass=organizationalRole)");
        (void)sprintf(ldap_filter, "%s(objectclass=room))", ldap_filter);
}
#else
makeAllPRRFilter(fpp)
struct s_filter ** fpp;
{
        gotFuzzyMatch = FALSE;
	(void)sprintf(filbuf, "(%s=*) | (%s=%s) |(%s=%s)", DE_SURNAME,
		DE_OBJECT_CLASS, DE_ROLE, DE_OBJECT_CLASS, DE_ROOM);
	*fpp = get_filter(filbuf);
}
#endif USELDAP

#ifdef USELDAP
void
makeExplicitPRRFilter(prrstr)
char * prrstr;
{
        gotFuzzyMatch = FALSE;
        (void)sprintf(ldap_filter, "(|(&(objectclass=person)(|(sn=%s)(cn=%s)))",
                                 prrstr, prrstr);
        (void)sprintf(ldap_filter, "%s(&(|(objectclass=organizationalRole)(objectclass=room))", ldap_filter);
        (void)sprintf(ldap_filter, "%s(cn=%s)))", ldap_filter, prrstr);
}
#else
void
makeExplicitPRRFilter(prrstr, fpp)
char * prrstr;
struct s_filter ** fpp;
{
        gotFuzzyMatch = FALSE;
        {
		(void)sprintf(filbuf, "((%s=%s) | (%s=%s)) & ((%s=*) |(%s=%s) | (%s=%s))", 
		    DE_COMMON_NAME, prrstr, DE_SURNAME, prrstr, 
		    DE_SURNAME, DE_OBJECT_CLASS, DE_ROLE,
		    DE_OBJECT_CLASS, DE_ROOM);
		*fpp = get_filter(filbuf);
	}
}
#endif USELDAP

#ifdef USELDAP
void
prrFilter1(prrstr)
char * prrstr;
{
char firststring[BUFSIZ];
char * fsp, * lsp, * laststring;

        gotFuzzyMatch = FALSE;
        /* if the string entered contains any spaces, form two substrings
           firstnamepart = all up to the first space
           lastnamepart  = all after last space */
        if (index(prrstr, ' ') != NULLCP)
        {
                (void) (void)strcpy(firststring, prrstr);
                fsp = index(firststring, ' ');
                *fsp = '\0';
                lsp = rindex(fsp + 1, ' ');
                if (lsp != NULLCP)
                        laststring = lsp++;
                else
                        laststring = fsp + 1;

                (void)sprintf(ldap_filter, "(|(&(cn=%s*)(cn=*%s))", firststring, laststring);
        }
        else
        {
                (void)sprintf(ldap_filter, "(|(sn=%s)", prrstr);
        }
        (void)sprintf(ldap_filter, "%s(&(cn=%s)(|(sn=*)(objectclass=room)(objectclass=organizationalRole))))",
                        ldap_filter, prrstr);
}
#else
void
prrFilter1(prrstr, fpp)
char * prrstr;
struct s_filter ** fpp;
{
char firststring[LINESIZE];
char * fsp, * lsp, * laststring;

        gotFuzzyMatch = FALSE;
	/* if the string entered contains any spaces, form two substrings
	   firstnamepart = all up to the first space
	   lastnamepart  = all after last space */
	if (index(prrstr, ' ') != NULLCP)
	{
		(void) (void)strcpy(firststring, prrstr);
		fsp = index(firststring, ' ');
		*fsp = '\0';
		lsp = rindex(fsp + 1, ' ');
		if (lsp != NULLCP)
			laststring = lsp++;
		else
			laststring = fsp + 1;
		
		(void)sprintf(filbuf, "(((%s=%s*)&(%s=*%s)&(%s=*))|", DE_COMMON_NAME,
		       firststring, DE_COMMON_NAME, laststring, DE_SURNAME);
	}
	else
		(void)sprintf(filbuf, "((%s=%s)|", DE_SURNAME, prrstr);
	(void)sprintf(filbuf, "%s((%s=%s)&((%s=%s)|(%s=%s))))", filbuf, 
	      DE_COMMON_NAME, prrstr, DE_OBJECT_CLASS, DE_ROLE, 
	      DE_OBJECT_CLASS, DE_ROOM);
	*fpp = get_filter(filbuf);
}
#endif USELDAP

#ifdef USELDAP
void
prrFilter2(prrstr)
char * prrstr;
{
char firststring[BUFSIZ];
char * fsp, * lsp, * laststring;

        gotFuzzyMatch = FALSE;
        /* if the string entered contains any spaces, and the string up to
           the first space is more than 1 character long, form two substrings

           firstnamepart = first initial (match against beginning of cn)
           lastnamepart  = all after last space (match against beg. of sn)

           this means that "paul barker" will match entries of "p barker" */
        ldap_filter[0] = '\0';
        if (index(prrstr, ' ') != NULLCP)
        {
                (void) (void)strcpy(firststring, prrstr);
                if (strlen(firststring) == 1)
                        return;
                fsp = index(firststring, ' ');
                firststring[1] = '\0';
                lsp = rindex(fsp + 1, ' ');
                if (lsp != NULLCP)
                        laststring = lsp++;
                else
                        laststring = fsp + 1;

                (void)sprintf(ldap_filter, "(&(cn=%s)(sn=%s)(sn=*))",
                                firststring, laststring);
        }
}
#else
void
prrFilter2(prrstr, fpp)
char * prrstr;
struct s_filter ** fpp;
{
char firststring[LINESIZE];
char * fsp, * lsp, * laststring;

        gotFuzzyMatch = FALSE;
	/* if the string entered contains any spaces, and the string up to
	   the first space is more than 1 character long, form two substrings
	   
	   firstnamepart = first initial (match against beginning of cn)
	   lastnamepart  = all after last space (match against beg. of sn)
	   
	   this means that "paul barker" will match entries of "p barker" */
	*fpp = NULLFILTER;
	if (index(prrstr, ' ') != NULLCP)
	{
		(void) (void)strcpy(firststring, prrstr);
		if (strlen(firststring) == 1)
			return;
		fsp = index(firststring, ' ');
		firststring[1] = '\0';
		lsp = rindex(fsp + 1, ' ');
		if (lsp != NULLCP)
			laststring = lsp++;
		else
			laststring = fsp + 1;
		
		(void)sprintf(filbuf, "(%s=%s*) & (%s=%s)", DE_COMMON_NAME, 
			firststring, DE_SURNAME, laststring);
		*fpp = get_filter(filbuf);
	}
}
#endif USELDAP

#ifdef USELDAP
void
prrFilter3(prrstr)
char * prrstr;
{
        gotFuzzyMatch = FALSE;
        (void)sprintf(ldap_filter, "(&(cn=*%s*)(|(sn=*)(objectclass=organizationalRole)(objectclass=room)))",
                prrstr);
}
#else
void
prrFilter3(prrstr, fpp)
char * prrstr;
struct s_filter ** fpp;
{
        gotFuzzyMatch = FALSE;
	(void)sprintf(filbuf, "(%s=*%s*) & ((%s=*)|(%s=%s)|(%s=%s))", 
	          DE_COMMON_NAME, prrstr, DE_SURNAME, DE_OBJECT_CLASS, DE_ROOM,
		  DE_OBJECT_CLASS, DE_ROLE);
	*fpp = get_filter(filbuf);
}
#endif USELDAP

#ifdef USELDAP
void
prrFilter4(prrstr)
char * prrstr;
{
	if (fuzzyMatching == FALSE)
	{
		(void)strcpy(ldap_filter, "");
		return;
	}
        gotFuzzyMatch = TRUE;
        (void)sprintf(ldap_filter, "(&(cn~=%s)(|(sn=*)(objectclass=organizationalRole)(objectclass=room)))",
                prrstr);
}
#else
void
prrFilter4(prrstr, fpp)
char * prrstr;
struct s_filter ** fpp;
{
	if (fuzzyMatching == FALSE)
	{
		*fpp = NULLFILTER;
		return;
	}
        gotFuzzyMatch = TRUE;
	(void)sprintf(filbuf, "(%s~=%s) & ((%s=*)|(%s=%s)|(%s=%s))", 
	          DE_COMMON_NAME, prrstr, DE_SURNAME, DE_OBJECT_CLASS, DE_ROOM,
		  DE_OBJECT_CLASS, DE_ROLE);
	*fpp = get_filter(filbuf);
}
#endif USELDAP

#ifdef USELDAP
void
exactSurname(prrstr)
char * prrstr;
{
        gotFuzzyMatch = FALSE;
	(void)sprintf(ldap_filter, "(sn=%s)", prrstr);
}
#else
void
exactSurname(prrstr, fpp)
char * prrstr;
struct s_filter ** fpp;
{
        gotFuzzyMatch = FALSE;
	(void)sprintf(filbuf, "(%s=%s)", DE_SURNAME, prrstr);
	*fpp = get_filter(filbuf);
}
#endif USELDAP

#ifdef USELDAP
void
makeAllPFilter()
{
        gotFuzzyMatch = FALSE;
	(void)sprintf(ldap_filter, "(sn=*)");
}
#else
void
makeAllPFilter(fpp)
struct s_filter ** fpp;
{
        gotFuzzyMatch = FALSE;
	(void)sprintf(filbuf, "(%s=*)", DE_SURNAME);
	*fpp = get_filter(filbuf);
}
#endif USELDAP
