/* power.c - routines for power searching */

#ifndef lint
static char *rcsid = "$Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/power.c,v 9.3 1993/03/19 22:55:58 isode Exp isode $";
#endif

/*
 * $Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/power.c,v 9.3 1993/03/19 22:55:58 isode Exp isode $
 *
 *
 * $Log: power.c,v $
 * Revision 9.3  1993/03/19  22:55:58  isode
 * Add QOS and DOS-DE code
 *
 * Revision 9.2  1992/12/15  07:05:26  awy
 * Update and fixes
 *
 * Revision 9.1  1992/11/12  20:05:23  awy
 * IC-1 base
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */

#define power_c
#ifdef DOS
#include <stdlib.h>
#include "proto-de.h"
#include <graph.h>
#endif DOS
#include "messages.h"

#include <stdio.h>
#include <string.h>
#include <setjmp.h>
#include <signal.h>
#ifdef USELDAP
#ifdef IC
#include <ldap/lber.h>
#include <ldap/ldap.h>
#else
#include <lber.h>
#include <ldap.h>
#endif /* IC */
#include <string.h>
#include "isomanifest.h"
#ifdef DOS
#include <msdos.h>
#else
#include <sys/time.h>
#endif DOS
#endif USELDAP
#include "demanifest.h"
#include "destrings.h"
#include "namelist.h"
#include "query.h"
#include "asyn.h"

jmp_buf abanbuf;

extern struct query qinfo[];
extern int boundToDSA;
extern int highNumber;
extern int goneAsync;
extern int dotsPrinted;

extern char matched[];

#ifndef USELDAP
extern struct ds_search_arg sarg;
extern struct ds_search_result sresult;
extern struct DSError serror;
#endif USELDAP

struct namelist * lp1;
extern struct opsPending * ops;
extern int noOpsAbandoned;

char
doPowerSearch()
{
int i, n, res, no_ops, no_orgs, opnum, opid, noFails, lookFor, pnum;
char c;
#ifdef DOS
void abandonops(int sig), onint1();
#else
void abandonops(), onint1();
#endif DOS
struct namelist * lp, * dlp, * fails, * successes, * x, * makeCombinedList();
struct opsPending * oplp;
char options[10];


  if (strlen(qinfo[PERSON].entered) == 0)
  {
    resetprint(NOPERSONNAME);
    return '\0';
  }
  else if (strcmp(qinfo[PERSON].entered, "*") == 0)
  {
    resetprint(NOPERSONNAME);
    return '\0';
  }

  fails = NULLLIST;
  successes = NULLLIST;
  noFails = 0;
  (void)initAbans();

  pagerOn(NUMBER_ALLOWED);

#ifdef DOS
  _clearscreen(_GCLEARSCREEN);
#endif
  res = doCountry();
  switch (res)
  {
    case QUERY_ERROR:
      goto escape;
    default:
      break;
  }

  if (strlen(qinfo[ORG].entered) == 0)
    (void)strcpy(qinfo[ORG].entered, "*");
  if (strcmp(qinfo[ORGUNIT].entered, "*") == 0)
    (void)strcpy(qinfo[ORGUNIT].entered, "");
  if (strlen(qinfo[ORGUNIT].entered) == 0)
    lookFor = PERSON;
  else
    lookFor = ORGUNIT;
  if (listOrgs(matched, qinfo[ORG].entered, &qinfo[ORG].lp) != OK)
    goto escape;
  no_orgs = qinfo[ORG].listlen = listlen(qinfo[ORG].lp);
  if (no_orgs == 0)
  {
    (void)printf(NOMATCHINGORGS, qinfo[ORG].entered);
    goto escape;
  }
  lp1 = qinfo[PERSON].lp = NULLLIST;
  highNumber = 0;

  /* fire off all the org searches */
  no_ops = 0;
  (void)printf(INITSEARCHES, qinfo[ORG].listlen);
  for (x = qinfo[ORG].lp; x != NULLLIST; x = x->next)
  {
    if (lookFor == PERSON)
      powerSearchPeople(x->name, qinfo[PERSON].entered, &opnum);
    else
      powerSearchOUs(x->name, qinfo[ORGUNIT].entered, &opnum);
    if ((no_ops %5) == 0) /* needs to be factored off to separate dot module */
    {
      (void)printf(".");
      (void) fflush(stdout);
      dotsPrinted++;
    }
    if (opnum == -1)
    {
      (void)printf(SEARCHINITFAIL, x->name);
      continue;
    }
    addToOpList(opnum, x->name, lookFor, NULLOPL);
    no_ops++;
  }
  
  /* now lets wait for them to come back */
  (void) resetprint(WAITING);
  (void)initAbans();
  goneAsync = TRUE;
#ifdef DOS
  (void) signal(SIGINT, SIG_IGN);
#else
  (void) signal(SIGINT, abandonops);
#endif DOS
  if (setjmp(abanbuf) == 0)
  {
    while (no_ops)
    {
      /* handle exits from pager */
      pnum = getpnum();
      if (quitPager() == TRUE) /* quit or number entered */
#ifdef DOS
        abandonops(0); /* this setjmps to menu below */
#else
        abandonops(); /* this setjmps to menu below */
#endif DOS
	
      (void)showOrgsToSearch(no_orgs);
#ifdef FOO
      (void)printf("List contains following orgs\n");
      for (oplp = ops; oplp != NULLOPL; oplp = oplp->next)
        (void)printf("%d %s\n", oplp->opno, oplp->orgname);
#endif FOO
      initAlarm();
      res = makeListForOneOrg(& opid);
      (void)clearOrgsToSearch();
      /* (void)printf("result for opno %d\n", opid); */
      oplp = findOp(opid);
      no_ops--;
      if (res == OK)
      {
        if (oplp == NULLOPL)
        {
          (void)fprintf(stderr, CANTFINDOP, opid);
        }
        else
        {
          if (oplp->lp != NULLLIST)
          {
	    if (oplp->type == ORGUNIT)
	    {
	      for (dlp = oplp->lp; dlp != NULLLIST; dlp = dlp->next)
	      {
	        powerSearchPeople(dlp->name, qinfo[PERSON].entered, &opnum);
		if (opnum == -1)
		  /* do something */;
		addToOpList(opnum, dlp->name, PERSON, oplp);
		no_ops++;
		oplp->subordSearches++;
	      }
	    }
	    else
	    {
              printListPRRs(qinfo[PERSON].entered, oplp->lp, ORG, 0, highNumber);
   	      lp1 = makeCombinedList(lp1, oplp->lp);
              if (qinfo[PERSON].lp == NULLLIST)
  	        qinfo[PERSON].lp = oplp->lp;
  	      highNumber += listlen(oplp->lp);
	    }
  	  }
  	  else
  	  {
  	  /* (void)printf("Nothing found for %s\n", orgNameFromDN(oplp->orgname), 1);*/
  	  }
        }
	if (oplp->parent == NULLOPL)
	  addToList(&successes, orgNameFromDN(oplp->orgname, 1));
      }
      else
      {
        if (oplp->parent == NULLOPL)
	{
          addToList(&fails, orgNameFromDN(oplp->orgname, 1));
          noFails++;
	}
      }
      if ((oplp->parent == NULLOPL) && (oplp->subordSearches == 0))
      {
        no_orgs--;
        (void)removeFromOpList(opid);
      }
      if (oplp->parent != NULLOPL)
        if ((n = removeFromOpList(opid)) != 0)
	{
	  (void)removeFromOpList(n); /*remove parent from list */
	  no_orgs--;
	}
#ifdef FOO
      (void)printf("Op list countConns %d, no_ops %d\n", countConns(), no_ops);
#endif FOO
    }
  }

  goneAsync = FALSE;
#ifdef DOS
  (void) signal(SIGINT, SIG_IGN);
#else
  (void) signal(SIGINT, onint1);
#endif DOS
  if (pnum != -1)
  {
    pagerOn(NUMBER_NOT_ALLOWED);
    printSelectedEntry(pnum);
  }
escape:
  for(;;)
  {
    (void)sprintf(options, "%c\n", QUITCHAR);
    if (qinfo[PERSON].lp == NULLLIST)
      pageprint(NOTHINGFOUND);
    else
    {
      pageprint(OPTIONS);
      (void)sprintf(options, "%s%c", options, LISTCHAR);
      pageprint(NUMBER);
      (void)sprintf(options, "%s#", options);
      pageprint(LIST, LISTCHAR);
    }
    if (successes != NULLLIST)
    {
      pageprint(SUCCESS, SUCCESSCHAR);
      (void)sprintf(options, "%s%c", options, SUCCESSCHAR);
    }
    if (noFails > 0)
    {
      pageprint(FAIL1, FAILCHAR);
      pageprint(FAIL2);
      (void)sprintf(options, "%s%c", options, FAILCHAR);
    }
    if (noOpsAbandoned > 0)
    {
      pageprint(ABAN, ABANCHAR);
      (void)sprintf(options, "%s%c", options, ABANCHAR);
    }
    pageprint(ANOTHER);
    pageprint(QUITPOWER, QUITCHAR);
    startUnbindTimer();
    c = enterOption(OPTSTRING, options, &n);
    stopUnbindTimer();
    if (qinfo[PERSON].lp == NULLLIST)
      pagerOn(NUMBER_ALLOWED);
    else
      pagerOn(NUMBER_NOT_ALLOWED);
    if (c == '#')
    {
      /* replace this with printSelectedEntry when we know it works OK */
      if (n > highNumber)
      {
        resetprint(RANGEPROBLEM);
	continue;
      }
      for (i = 1, lp = qinfo[PERSON].lp; i < n; i++, lp = lp->next){};
      printEntry(lp->name);
      printDetails(PERSON, lp);
      continue;
    }
    if (c ==  LISTCHAR)
    {
      pagerOn(NUMBER_ALLOWED);
      printListPRRs(qinfo[PERSON].entered, qinfo[PERSON].lp, ORG, 0, 0);
      if ((n = getpnum()) != -1)
      {
        pagerOn(NUMBER_NOT_ALLOWED);
        printSelectedEntry(n);
      }
      continue;
    }
    if (c == SUCCESSCHAR)
    {
      pagerOn(NUMBER_NOT_ALLOWED);
      (void)printOrgReport(OKSEARCH, successes);
      continue;
    }
    if (c == FAILCHAR)
    {
      pagerOn(NUMBER_NOT_ALLOWED);
      (void)printOrgReport(CANTSEARCH,fails);
      continue;
    }
    if (c == ABANCHAR)
    {
      pagerOn(NUMBER_NOT_ALLOWED);
      (void)printOrgAbandons();
      continue;
    }
    break; /* return */
  }
  freeList(&successes);
  freeList(&fails);
  initAbans();
  freePRRs(&qinfo[PERSON].lp);
  return c;
}

struct namelist *
makeCombinedList(main, addthis)
struct namelist * main, * addthis;
{
struct namelist * lp;

  if (main != NULLLIST)
    main->next = addthis;
  for (lp = addthis; lp->next != NULLLIST; lp = lp->next){};
  return(lp);
}

#ifdef DOS
void
#endif DOS
printOrgReport(message, lp)
char * message;
struct namelist * lp;
{
struct namelist * tmp;
  pageprint(message);
 for (tmp = lp ;tmp != NULLLIST; tmp = tmp->next)
    pageprint("  %s\n", tmp->name);
}

/* make sure all indexes are replaced by strstr ... and that strings
   are replaced by SHORT_CO etc */
   /* NO - THROW AWAY AND START AGAIN - THIS IS CRUDE BEYOND BELIEF */
#ifdef DOS
void
#endif DOS
printEntry(dnstr)
char * dnstr;
{
char * cp, * cp2, * savecp;

	savecp = cp = cp2 = copy_string(dnstr);
#ifdef USELDAP
	cp = rindex(savecp, ',');
	if (cp == NULLCP)
	  return;
	*cp++ = '\0';
	printLastComponent(INDENTON, cp, COUNTRY, 0);
	cp = rindex(savecp, ',');
	if (cp == NULLCP)
	  return;
	*cp++ = '\0';
	printLastComponent(INDENTON, cp, ORG, 0);
	cp = removeLastRDN(savecp);
	if (cp != NULLCP)
	  printLastComponent(INDENTON, cp, ORGUNIT, 0);
	printLastComponent(INDENTON, savecp, PERSON, 0);
	free(cp);
#else
	cp = index(cp, '@');
	if (cp == NULLCP)
	  return;
	else
	{
	  *cp = '\0';
	  printLastComponent(INDENTON, cp2, COUNTRY, 0);
	  cp2 = ++cp;
	  if (strstr(cp2, "@o=") != NULLCP)
	  {
	    cp2 = strstr(cp2, "@o=");
	    cp2++;
	  }
	  cp = index(cp2, '@');
	  if (cp == NULLCP)
	    return;
	  else
	  {
	    *cp = '\0';
	    printLastComponent(INDENTON, cp2, ORG, 0);
	    cp2 = removeLastRDN(++cp);
	    if (cp2 != NULLCP)
              printLastComponent(INDENTON, cp2, ORGUNIT, 0);
	    free(cp2);
	    printLastComponent(INDENTON, cp, PERSON, 0);
	  }
	}
#endif USELDAP
	free(savecp);
}

#ifdef DOS
void
#endif DOS
showOrgsToSearch(orgs)
#ifdef DOS
int orgs;
#endif
{
  (void)printf("%s %3d", STILLTODOMESS, orgs);
  (void)fflush(stdout);
}

#ifdef DOS
void
#endif DOS
clearOrgsToSearch()
{
int i;
#ifdef DOS
int len;
struct _rccoord curpos;

  len = strlen(STILLTODOMESS) + 4;
  curpos = _gettextposition();
  _settextposition(curpos.row, curpos.col - len);
  for (i = 0; i < len; i++)
    _outtext(" ");
  _settextposition(curpos.row, curpos.col - len);
#else

  for (i = 0; i < ((int)strlen(STILLTODOMESS) + 4); i++)
    (void)printf("\b \b");
#endif DOS
}

#ifdef DOS
void
#endif DOS
printSelectedEntry(entNo)
int entNo;
{
struct namelist * lp;
int i;
  if (entNo > highNumber)
  {
    resetprint(RANGEPROBLEM);
    return;
  }
  for (i = 1, lp = qinfo[PERSON].lp; i < entNo; i++, lp = lp->next){};
    printEntry(lp->name);
  printDetails(PERSON, lp);
}
