/* ufnp.c - user-friendly name resolution */
/* this is a hacked version of the ufn_parse.c routines.
   Major mod is to only return up to maxPersons leaf matches - otherwise
   interact routine is called */
#ifndef lint
static char *rcsid = "$Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/ufnp.c,v 9.3 1993/03/19 22:56:11 isode Exp isode $";
#endif

/*
 * $Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/ufnp.c,v 9.3 1993/03/19 22:56:11 isode Exp isode $
 *
 *
 * $Log: ufnp.c,v $
 * Revision 9.3  1993/03/19  22:56:11  isode
 * Add QOS and DOS-DE code
 *
 * Revision 9.2  1992/12/15  07:05:26  awy
 * Update and fixes
 *
 * Revision 9.1  1992/11/12  20:05:23  awy
 * IC-1 base
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */

#ifdef DOS
#include <stdlib.h>
#include "proto-de.h"
#include <ctype.h>
#endif DOS
#ifdef USELDAP
#include <string.h>
#ifdef IC
#include <ldap/lber.h>
#include <ldap/ldap.h>
#else
#include <lber.h>
#include <ldap.h>
#endif /* IC */
#include "isomanifest.h"
#include "namelist.h"
#ifdef DOS
#include <msdos.h>
#else
#include <sys/time.h>
#endif DOS
#include "destrings.h"
#include "demanifest.h"
#include <signal.h>
#else
#include "quipu/ufn.h"
#ifdef IC
#include "compat/tailor.h"
#else
#include "tailor.h"
#endif /* IC */
#include "quipu/list.h"
#include "quipu/ds_search.h"
#include "quipu/connection.h"	/* ds_search uses di_block - include this for lint !!! */
#include "quipu/dua.h"
#endif USELDAP
#ifdef DOS
#undef putchar
#define putchar(c) gputchar(c)
#endif

#ifdef USELDAP
/* stuff from h/quipu/ufn.h */

typedef struct _envlist {
	struct namelist * Dns;
	int Upper;
	int Lower;
	struct _envlist * Next;
} * envlist;

#define NULLEL ((envlist) NULL)

envlist	read_envlist ();

#define	UFN_NULL	0x00
#define	UFN_APPROX	0x01
#define	UFN_WILDHEAD	0x02
#define	UFN_ALL		(UFN_APPROX | UFN_WILDHEAD)
#endif USELDAP

char ufn_notify = FALSE;
int ufn_flags = UFN_ALL;

#ifndef USELDAP
extern char PY_pepy[];
#endif USELDAP
#define NOTIFY(x) if (ufn_notify) (void) printf x, (void) putchar('\n'); else ;

#ifdef USELDAP
struct namelist * ufnatts = NULLLIST;
extern LDAP * ldap_ld;
extern char * ldap_base;
extern int ldap_scope;
extern char * ldap_filter;
extern char ** ldap_attrs;
extern char ldap_attrsonly;
extern int ldap_msgid;
extern int ldap_all;
extern struct timeval ldap_timeout;
extern LDAPMessage * ldap_res;
LDAPMessage * entry_dup();
#ifndef DOS
extern FILE *de_log;
#endif DOS
extern char * TidyString(), * SkipSpace();
extern char * quipuDN2DS23DN();
char * getenv();
#else
AttributeType at_OrgUnit;
AttributeType at_Organisation;
AttributeType at_Locality;
AttributeType at_CountryName;
AttributeType at_FriendlyCountryName;
AttributeType at_CommonName;
AttributeType at_Surname;
AttributeType at_Userid;

AttributeType at_ObjectClass;

Attr_Sequence ufnas = NULL;

extern LLog * log_dsap;

extern char *TidyString();

extern Filter strfilter ();
extern Filter ocfilter ();
extern Filter joinfilter ();
extern struct dn_seq *dn_seq_push ();
#endif USELDAP

/* shouldn't really be maxPersons - semantics are max leaf entries */
extern int maxPersons;

char ufn_abort = FALSE;		/* external to force UFN to abort */

#ifdef DE-DEBUG
static	print_search ();
#endif 

#ifdef USELDAP
struct namelist * DNS_append(a, b)
struct namelist * a, * b;
{
  struct namelist * c;
  if (a == NULLLIST)
    return b;

  for (c = a; c->next != NULLLIST; c = c->next)
    ; /* Nothing */

  c->next = b;

  return a;
}
#else
DNS DNS_append (a,b)
DNS a, b;
{	
DNS c;
	if (a == NULLDNS)
		return b;

	for (c=a; c->dns_next != NULLDNS; c=c->dns_next)
		; /* Nothing */

	c->dns_next = b;

	return a;
}
#endif USELDAP

#ifndef USELDAP
static Attr_Sequence read_cache (base)
DN base;
{
Entry ptr;

	if ((ptr = local_find_entry (base,FALSE)) != NULLENTRY) 
		return (ptr->e_attributes);

	return NULLATTR;
}
#endif USELDAP

int
countMatches(dns)
#ifdef USELDAP
struct namelist * dns;
#else
DNS dns;
#endif USELDAP
{
int i;

#ifdef USELDAP
	for (i = 0; dns != NULLLIST; dns = dns->next, i++);
#else
	for (i = 0; dns != NULLDNS; dns = dns->dns_next, i++);
#endif USELDAP
	return i;
}

#ifdef USELDAP
static char exact_match (dn, ats, s) 
char * dn;
LDAPMessage * ats;
char * s;
{
  char * p1, * p2;
  BerElement * cookie;
  char * at;
  char ** avp;
  int i;

  p1 = lastRDN(dn);
  if ((p2 = index(p1, '=')) != NULLCP)
    p1 = p2 + 1;
  if (lexequ(p1, s) == 0)
    return TRUE;

  for (at = ldap_first_attribute(ldap_ld, ats, &cookie);
                at != NULL; at = ldap_next_attribute(ldap_ld, ats, cookie))
  {
    avp = ldap_get_values(ldap_ld, ats, at);
    for (i=0; avp[i] != NULL; i++)
      if (lexequ(avp[i], s) == 0) {
        ldap_value_free(avp);
	return TRUE;
    }
    ldap_value_free(avp);
  }

  return FALSE;
}
#else
static char exact_match (dn,s) 
DN dn;
char * s;
{
RDN rdn;
	for (; dn->dn_parent != NULLDN; dn=dn->dn_parent)
		; /* Nothing */

	for (rdn = dn->dn_rdn; rdn != NULLRDN; rdn=rdn->rdn_next) {
		if (sub_string (rdn->rdn_av.av_syntax)
		&& (lexequ((char *)rdn->rdn_av.av_struct,s) == 0))
			return TRUE;
	}
	return FALSE;
}
#endif USELDAP

#ifdef USELDAP
static char good_match(dn, ats, s) 
char * dn;
LDAPMessage * ats;
char * s;
{
  char * p1, * p2;
  BerElement * cookie;
  char * at;
  char ** avp;
  int i;

  p1 = lastRDN(dn);
  if ((p2 = index(p1, '=')) != NULLCP)
    p1 = p2 + 1;
  if (sub_string(p1, s) == 0)
    return TRUE;

  for (at = ldap_first_attribute(ldap_ld, ats, &cookie);
                at != NULL; at = ldap_next_attribute(ldap_ld, ats, cookie))
  {
    avp = ldap_get_values(ldap_ld, ats, at);
    for (i=0; avp[i] != NULL; i++)
      if (sub_string(avp[i], s) == 0) {
        ldap_value_free(avp);
	return TRUE;
    }
    ldap_value_free(avp);
  }

  return FALSE;
}
#else
static char good_match (dn,s) 
DN dn;
char * s;
{
Attr_Sequence as;
AV_Sequence avs;

	for (as = read_cache(dn); as != NULLATTR; as=as->attr_link)
		for (avs=as->attr_value; avs!= NULLAV; avs=avs->avseq_next)
			if (sub_string (avs->avseq_av.av_syntax)
				&& (lexequ((char *)avs->avseq_av.av_struct,s) == 0))
					return TRUE;
	return FALSE;
}
#endif USELDAP

#ifdef USELDAP
dnSelect(s, dlist, interact, el, leafFlag)
char * s;
struct namelist ** dlist;
struct namelist * (* interact) ();
struct namelist * el;
int leafFlag;
{
  struct namelist * exact = NULLLIST;
  struct namelist * good  = NULLLIST;
  struct namelist * bad   = NULLLIST;
  struct namelist * tmp, * next = NULLLIST;

  if ((dlist == (struct namelist **) NULL) || (*dlist == NULLLIST))
    return 2;

  for (tmp= *dlist; tmp != NULLLIST; tmp=next) {
    next = tmp->next;
    if (exact_match(tmp->name, tmp->ats, s)) {
      tmp->next = exact;
      exact = tmp;
    } else if (good_match(tmp->name, tmp->ats, s)) {
      tmp->next = good;
      good = tmp;
    } else {
      tmp->next = bad;
      bad = tmp;
    }
  }

  if (exact) {
    NOTIFY (("Found exact match(es) for '%s'", s));
    *dlist = exact;
    if (leafFlag && (countMatches(exact) > maxPersons))
    {
      *dlist = (*interact)(exact, el->name, s);
      if (*dlist)
      {
        freeList(&good);
        freeList(&bad);
        return TRUE;
      }
    }
    else
    {
      freeList (&good);
      freeList (&bad);
      return TRUE;
    }
  }

  if (good) {
    NOTIFY (("Found good match(es) for '%s'", s));
    *dlist = good;
    if (leafFlag && (countMatches(good) > maxPersons))
    {
      *dlist = (*interact)(good, el->name, s);
      if (*dlist)
      {
        freeList (&bad);
        return TRUE;
      }
    }
    else
    {
      freeList (&bad);
      return TRUE;
    }
  }

  good = (*interact)(bad, el->name, s);
  *dlist = good;
  if (good != NULLLIST)
    return TRUE;
  else
    return 2;  /* back track allowed ! */

}
#else
dnSelect (s,dlist,interact,el, leafFlag)
char * s;
DNS *dlist;
DNS (* interact) ();
DNS el;
int leafFlag;
{
DNS exact = NULLDNS;
DNS good  = NULLDNS;
DNS bad   = NULLDNS;
DNS tmp, next = NULLDNS;

	if ((dlist == (DNS *)NULL) || (*dlist == NULLDNS))
		return 2;

	for (tmp= *dlist; tmp != NULLDNS; tmp=next) {
		next = tmp->dns_next;
		if (exact_match(tmp->dns_dn,s)) {
			tmp->dns_next = exact;
			exact = tmp;
		} else if (good_match(tmp->dns_dn,s)) {
			tmp->dns_next = good;
			good = tmp;
		} else {
			tmp->dns_next = bad;
			bad = tmp;
		}
	}


	if (exact) {
		NOTIFY (("Found exact match(es) for '%s'",s));
		*dlist = exact;
		if (leafFlag && (countMatches(exact) > maxPersons))
		{
		  *dlist = (*interact)(exact,el->dns_dn,s);
		  if (*dlist)
		  {
		    dn_seq_free (good);
		    dn_seq_free (bad);
		    return TRUE;
		  }
		}
		else
		{
		  dn_seq_free (good);
		  dn_seq_free (bad);
		  return TRUE;
		}
	}

	if (good) {
		NOTIFY (("Found good match(es) for '%s'",s));
		*dlist = good;
		if (leafFlag && (countMatches(good) > maxPersons))
		{
		  *dlist = (*interact)(good,el->dns_dn,s);
		  if (*dlist)
		  {
		    dn_seq_free (bad);
		    return TRUE;
		  }
		}
		else
		{
		  dn_seq_free (bad);
		  return TRUE;
		}
	}

	good = (*interact)(bad,el->dns_dn,s);
	*dlist = good;
	if (good != NULLDNS)
		return TRUE;
	else
		return 2;	/* back track allowed ! */

}
#endif USELDAP

#ifdef USELDAP
char * ufn_bad_dsa = NULLCP;
struct namelist * ufn_partials = NULLLIST;
#else
DN	ufn_bad_dsa = NULLDN;
DNS	ufn_partials = NULLDNS;
#endif USELDAP

#ifdef USELDAP
static char present (d, t)
char * d;
char * t;
{
  char * p1, newt[LINESIZE];

  (void)strcpy(newt, t);
  (void)strcat(newt, "=");
  p1 = d;
  while (*p1 != '\0') {
    if (strncmp(p1, newt, strlen(newt)) == 0) return TRUE;
    for ( ; *p1 != ','; p1++)
      if (*p1 == '\0') return FALSE;
    for (p1++; *p1 == ' '; p1++)
      if (*p1 == '\0') return FALSE;
  }
}
#else
static char present (d,t)
DN d;
AttributeType t;
{
RDN rdn;
DN p, q;

	if (!d)
	    return FALSE;

	for (p = d; p -> dn_parent; p = p -> dn_parent)
	    continue;
	for (;;) {
	    for (rdn = p -> dn_rdn; rdn; rdn = rdn -> rdn_next)
		if (AttrT_cmp (rdn->rdn_at,t) == 0)
			return TRUE;
	    if (p == d)
		return FALSE;	/* more work ... */
	    for (q = d; p != q -> dn_parent; q = q -> dn_parent)
		continue;
	    p = q;
	}
}
#endif USELDAP

#ifdef USELDAP
ufn_search (base, subtree, filt, res, s, interact, el, leafFlag)
char * base;
char subtree;
char * filt;
struct namelist ** res;
char * s;
struct namelist * (* interact) ();
struct namelist * el;
int leafFlag;
{
  struct namelist * newdns, * r = NULLLIST;
  int scope;
  struct timeval tv;
#ifndef DOS
  void (*sigintfn)();
#endif DOS
  int retval;
  LDAPMessage * enp;
  char ** atpp;

  if (ufn_abort) {
    (*res) = NULLLIST;
    return FALSE;
  }

  if (subtree)
    scope = LDAP_SCOPE_SUBTREE;
  else  
    scope = LDAP_SCOPE_ONELEVEL;

#ifdef DE-DEBUG
/*
  if (ufn_notify == 2)
 */
    print_search (base, subtree, filt);
#endif

  atpp = makeAllAttrs(ufnatts);

#ifndef DOS
  sigintfn = signal(SIGINT, SIG_IGN);
#endif DOS
  retval = ldap_search(ldap_ld, base, scope, filt, atpp, 0);
#ifndef DOS
  (void) signal(SIGINT, sigintfn);
#endif DOS
  if (retval == -1)
  {
    ldap_perror(ldap_ld, "ufn_search");
    return FALSE;
  }
  ldap_msgid = retval;
/*
  setProblemFlags(ldap_ld->ld_errno);
 */
  tv.tv_sec = 2;
  tv.tv_usec = 0;
  while ((retval = ldap_result(ldap_ld, ldap_msgid, 1, &tv, &ldap_res)) == 0)
    doInProgress();
  ldap_msgid = 0;
  if (retval < 0)
  {
    ldap_perror(ldap_ld, "ufn_search");
    return FALSE;
  }

  /* OK, we appear to have a result... let's just check the result type
     and make sure!  It should be either LDAP_RES_SEARCH_ENTRY or
     LDAP_RES_SEARCH_RESULT I think. */
  if (ldap_res->lm_msgtype != LDAP_RES_SEARCH_ENTRY &&
      ldap_res->lm_msgtype != LDAP_RES_SEARCH_RESULT)
    return FALSE;

  if (ldap_ld->ld_errno == LDAP_TIMELIMIT_EXCEEDED ||
      ldap_ld->ld_errno == LDAP_SIZELIMIT_EXCEEDED)
    NOTIFY (("Continuing with partial results !"));

  if (ldap_count_entries(ldap_ld, ldap_res) > 0)
    for (enp = ldap_first_entry(ldap_ld, ldap_res); enp != NULL;
		enp = ldap_next_entry(ldap_ld, enp))
    {
      newdns = list_alloc();
      newdns->name = ldap_get_dn(ldap_ld, enp);
      newdns->ats = entry_dup(enp);
      newdns->next = r;
      r = newdns;
    }

  *res = r;

  return dnSelect(s, res, interact, el, leafFlag);
}
#else
ufn_search (base, subtree, filt, res, s, interact, el, leafFlag)
DN base;
char subtree;
Filter filt;
DNS * res;
char * s;
DNS (* interact) ();
DNS el;
int leafFlag;
{
struct ds_search_arg search_arg;
static struct ds_search_result result;
struct DSError err;
static CommonArgs ca = default_common_args;
EntryInfo * ptr;
DNS newdns, r = NULLDNS;

	if (ufn_abort) {
	    (*res) = NULLDNS;
	    return FALSE;
	}

	search_arg.sra_baseobject = base;
	search_arg.sra_filter = filt;
	if (subtree)
		search_arg.sra_subset = SRA_WHOLESUBTREE;
	else	
		search_arg.sra_subset = SRA_ONELEVEL;
	search_arg.sra_searchaliases = TRUE;
	search_arg.sra_common = ca; /* struct copy */
	search_arg.sra_eis.eis_infotypes = TRUE;
	search_arg.sra_eis.eis_allattributes = FALSE;
	search_arg.sra_eis.eis_select = ufnas;

#ifdef DE-DEBUG
/*
	if (ufn_notify == 2)
 */
	    print_search (base, subtree, filt);
#endif
/*
	if (ds_search (&search_arg, &err, &result) != DS_OK) {
*/
	if (de_search (&search_arg, &err, &result) != DS_OK) {
		log_ds_error (&err);
		NOTIFY (("DAP Search returned an error"))
		if (!ufn_bad_dsa) {
		    switch (err.dse_type) {
		        case DSE_REFERRAL:
		            if (err.ERR_REFERRAL.DSE_ref_candidates 
			            && err.ERR_REFERRAL.DSE_ref_candidates
					    -> cr_reftype
						!= RT_NONSPECIFICSUBORDINATE)
				goto set_bad_dsa;
			    break;

			case DSE_DSAREFERRAL:
			    if (err.ERR_REFERRAL.DSE_ref_candidates) {
set_bad_dsa: ;
				ufn_bad_dsa =
				    dn_cpy (err.ERR_REFERRAL.DSE_ref_candidates
					    -> cr_accesspoints -> ap_name);
			    }
			    break;

			default:
			    break;
		    }
		}
		ds_error_free (&err);
		filter_free (filt);
		return FALSE;
	}

	filter_free (filt);
	correlate_search_results (&result);

	dn_free (result.CSR_object);

	if ( (result.CSR_limitproblem != LSR_NOLIMITPROBLEM) || (result.CSR_cr != NULLCONTINUATIONREF)) {
	        if (!ufn_bad_dsa && result.CSR_cr)
		    ufn_bad_dsa = dn_cpy (result.CSR_cr -> cr_accesspoints
					  		-> ap_name);

		crefs_free (result.CSR_cr);

		if ( ! result.CSR_entries) {
			NOTIFY (("Search returned partial results"))
			return FALSE;
		} 
		NOTIFY (("Continuing with partial results !"));
	}

	if (!result.CSR_entries
	        && check_dnseq (ufn_partials, base) == NOTOK
	        && present (base, at_Organisation))
	    ufn_partials = dn_seq_push (base, ufn_partials);

	for (ptr = result.CSR_entries; ptr != NULLENTRYINFO; ptr=ptr->ent_next) {
		cache_entry (ptr, search_arg.sra_eis.eis_allattributes,
			     search_arg.sra_eis.eis_infotypes);
		newdns = dn_seq_alloc();
		newdns->dns_next = r;
		newdns->dns_dn = dn_cpy (ptr->ent_dn);
		r = newdns;
	}
	entryinfo_free (result.CSR_entries,0);

	*res = r;

	return dnSelect (s,res,interact,el, leafFlag);
}

#define	SUBSTRINGS()	((ufn_flags & UFN_WILDHEAD) ? FILTERITEM_SUBSTRINGS \
			 			    : -FILTERITEM_SUBSTRINGS)
#endif USELDAP

#ifdef USELDAP
static rootSearch (s, interact, el, result)
char * s;
struct namelist * (* interact) ();
struct namelist * el;
struct namelist ** result;
{
    char filt[LINESIZE];

    if (strlen(s) == 2)
	(void)sprintf(filt, "(|(countryName=%s)(friendlyCountryName=%s)(organizationName=%s))", s, s, s);
    else {
	(void)sprintf(filt, "(|(friendlyCountryName=%s)(organizationName=%s)(localityName=%s)", s, s, s);
	if ((ufn_flags & UFN_APPROX) && !index (s, '*'))
	    (void)sprintf(filt, "%s(friendlyCountryName~=%s)(organizationName~=%s)(localityName~=%s)",
		filt, s, s, s);
    }
    (void)sprintf(filt, "%s)", filt);

    return ufn_search ("", FALSE, filt, result, s, interact, el, FALSE);
}
#else
static rootSearch (s,interact,el,result)
char * s;
DNS (* interact) ();
DNS el;
DNS * result;
{
    Filter filt, filta, filtb, filtc, filtd, filte, filtf;

    if (check_3166 (s)) {
	if ((filta = strfilter (at_CountryName,s,FILTERITEM_EQUALITY)) == NULLFILTER)
	    return 0;
	if ((filtb = strfilter (at_FriendlyCountryName,s,FILTERITEM_EQUALITY)) == NULLFILTER)
	    return 0;
	filtb -> flt_next = filta;
	if ((filtc = strfilter (at_Organisation,s,FILTERITEM_EQUALITY)) == NULLFILTER)
	    return 0;
	filtc -> flt_next = filtb;
	filt = joinfilter (filtc, FILTER_OR);
    }
    else {
	if ((filta = strfilter (at_FriendlyCountryName,s,SUBSTRINGS ())) == NULLFILTER)
	    return 0;
	if ((filtc = strfilter (at_Organisation,s,SUBSTRINGS ())) == NULLFILTER)
	    return 0;
	filtc -> flt_next = filta;
	if ((filte = strfilter (at_Locality,s,SUBSTRINGS ())) == NULLFILTER)
	    return 0;
	filte -> flt_next = filtc;
	if ((ufn_flags & UFN_APPROX) && !index (s, '*')) {
	    if ((filtb = strfilter (at_FriendlyCountryName,s,FILTERITEM_APPROX)) == NULLFILTER)
		return 0;
	    filtb -> flt_next = filte;
	    if ((filtd = strfilter (at_Organisation,s,FILTERITEM_APPROX)) == NULLFILTER)
		return 0;
	    filtd -> flt_next = filtb;
	    if ((filtf = strfilter (at_Locality,s,FILTERITEM_APPROX)) == NULLFILTER)
		return 0;
	    filtf -> flt_next = filtd;
	    filt = joinfilter (filtf, FILTER_OR);
	}
	else
	    filt = joinfilter (filte, FILTER_OR);
    }

    return ufn_search (NULLDN,FALSE,filt,result,s,interact,el,FALSE);
}
#endif USELDAP

#ifdef USELDAP
static intSearch (base, s, interact, el, result)
char * base;
char * s;
struct namelist * (* interact) ();
struct namelist * el;
struct namelist ** result;
{
    char filt[LINESIZE];

    if (present(base, SHORT_OU)) {
	if ((ufn_flags & UFN_APPROX) && !index (s, '*'))
	    (void)sprintf(filt, "(&(objectclass=organizationalUnit)(|(organizationalUnitName=*%s*)(organizationalUnitName~=%s)))", s, s);
	else
	    (void)sprintf(filt, "(&(objectclass=organizationalUnit)(organizationalUnitName=*%s*))", s);
    } else if (present(base, SHORT_ORG)) {
	(void)sprintf(filt, "(&(|(objectclass=organizationalUnit)(objectclass=locality))");
	if ((ufn_flags & UFN_APPROX) && !index (s, '*'))
	    (void)sprintf(filt, "%s(|(organizationalUnitName=*%s*)(localityName=*%s*)(organizationalUnitName~=%s)(localityName~=%s)))",
		filt, s, s, s, s);
	else
	    (void)sprintf(filt, "%s(|(organizationalUnitName=*%s*)(localityName=*%s*)))",
		filt, s, s);
    } else if (present(base, SHORT_LOC)) {
	if ((ufn_flags & UFN_APPROX) && !index (s, '*'))
	    (void)sprintf(filt, "(&(objectclass=organization)(|(organizationName=*%s*)(organizationName~=%s)))", s, s);
	else
	    (void)sprintf(filt, "(&(objectclass=organization)(organizationName=*%s*))", s);
    } else {
	(void)sprintf(filt, "(&(|(objectclass=organization)(objectclass=locality))");
	if ((ufn_flags & UFN_APPROX) && !index (s, '*'))
	    (void)sprintf(filt, "%s(|(organizationName=*%s*)(localityName=*%s*)(organizationName~=%s)(localityName~=%s)))",
		filt, s, s, s, s);
	else
	    (void)sprintf(filt, "%s(|(organizationName=*%s*)(localityName=*%s*)))",
		filt, s, s);
    }

    return ufn_search(base, FALSE, filt, result, s, interact, el, FALSE);
}
#else
static intSearch (base,s,interact,el,result)
DN base;
char * s;
DNS (* interact) ();
DNS el;
DNS * result;
{
Filter filt, filta, filtb, filtc, filtd, filte, filtf, filtg, filth;

	if ( present (base,at_OrgUnit) ) {
		if ((filte = ocfilter ("OrganizationalUnit")) == NULLFILTER)
			return FALSE;

		if ((filta = strfilter (at_OrgUnit,s,SUBSTRINGS ())) == NULLFILTER)
		    return 0;
		if ((ufn_flags & UFN_APPROX) && !index (s, '*')) {
		    if ((filtb = strfilter (at_OrgUnit,s,FILTERITEM_APPROX)) == NULLFILTER)
			return 0;
		    filtb->flt_next = filta;
		    filt = joinfilter (filtb, FILTER_OR);
		}
		else
		    filt = filta;

		filte->flt_next = filt;

		filtf = joinfilter (filte, FILTER_AND);
	} else if ( present (base,at_Organisation) ) {
		if ((filte = ocfilter ("OrganizationalUnit")) == NULLFILTER)
			return FALSE;
		if ((filth = ocfilter ("Locality")) == NULLFILTER) {
		    filter_free (filte);
		    return FALSE;
		}
		filth->flt_next = filte;
		filtg = joinfilter (filth, FILTER_OR);

		if ((filta = strfilter (at_OrgUnit,s,SUBSTRINGS ())) == NULLFILTER)
		    return 0;
		if ((filtc = strfilter (at_Locality,s,SUBSTRINGS ())) == NULLFILTER)
		    return 0;
		filtc -> flt_next = filta;
		if ((ufn_flags & UFN_APPROX) && !index (s, '*')) {
		    if ((filtb = strfilter (at_OrgUnit,s,FILTERITEM_APPROX)) == NULLFILTER)
			return 0;
		    filtb -> flt_next = filtc;
		    if ((filtd = strfilter (at_Locality,s,FILTERITEM_APPROX)) == NULLFILTER)
			return 0;
		    filtd -> flt_next = filtb;
		    filt = joinfilter (filtd, FILTER_OR);
		}
		else
		    filt = joinfilter (filtc, FILTER_OR);

		filtg->flt_next = filt;
		filtf = joinfilter (filtg, FILTER_AND);
	} else if ( present (base,at_Locality) ) {
		if ((filte = ocfilter ("Organization")) == NULLFILTER)
			return FALSE;

		if ((filta = strfilter (at_Organisation,s,SUBSTRINGS ())) == NULLFILTER)
		    return 0;
		if ((ufn_flags & UFN_APPROX) && !index (s, '*')) {
		    if ((filtb = strfilter (at_Organisation,s,FILTERITEM_APPROX)) == NULLFILTER)
			return 0;
		    filtb->flt_next = filta;
		    filt = joinfilter (filtb, FILTER_OR);
		}
		else
		    filt = filta;

		filte->flt_next = filt;

		filtf = joinfilter (filte, FILTER_AND);
	} else {
		if ((filte = ocfilter ("Organization")) == NULLFILTER)
		    return FALSE;
		if ((filth = ocfilter ("Locality")) == NULLFILTER) {
		    filter_free (filte);
		    return FALSE;
		}
		filth -> flt_next = filte;
		filtg = joinfilter (filth, FILTER_OR);

		if ((filta = strfilter (at_Organisation,s,SUBSTRINGS ())) == NULLFILTER)
		    return 0;
		if ((filtc = strfilter (at_Locality,s,SUBSTRINGS ())) == NULLFILTER)
		    return 0;
		filtc -> flt_next = filta;
		if ((ufn_flags & UFN_APPROX) && !index (s, '*')) {
		    if ((filtb = strfilter (at_Organisation,s,FILTERITEM_APPROX)) == NULLFILTER)
			return 0;
		    filtb -> flt_next = filtc;
		    if ((filtd = strfilter (at_Locality,s,FILTERITEM_APPROX)) == NULLFILTER)
			return 0;
		    filtd -> flt_next = filtb;
		    filt = joinfilter (filtd, FILTER_OR);
		}
		else
		    filt = joinfilter (filtc, FILTER_OR);

		filtg->flt_next = filt;
		filtf = joinfilter (filtg, FILTER_AND);
	}

    return ufn_search (base,FALSE,filtf,result,s,interact,el, FALSE);
}
#endif USELDAP

#ifdef USELDAP
static leafSearch(base, s, subtree, interact, el, result)
char * base;
char * s;
char subtree;
struct namelist * (* interact) ();
struct namelist * el;
struct namelist ** result;
{
    char filt[LINESIZE];
    char filt1[LINESIZE];

    (void)sprintf(filt1, "(commonName=*%s*)(surname=*%s*)(uid=*%s*)", s, s, s);
    if ((ufn_flags & UFN_APPROX) && !index (s, '*'))
	(void)sprintf(filt, "(|%s)", filt1);
    else
	(void)sprintf(filt, "(|%s(commonName~=%s)(surname~=%s)(uid~=%s))", filt1, s, s, s);

    return ufn_search(base, subtree, filt, result, s, interact, el, TRUE);
}
#else
static leafSearch (base,s,subtree,interact,el,result)
DN base;
char * s;
char subtree;
DNS (* interact) ();
DNS el;
DNS * result;
{
Filter filt, filta, filtb, filtc, filtd, filte, filtf;

	if ((filta = strfilter (at_CommonName,s,SUBSTRINGS ())) == NULLFILTER)
	    return 0;
	if ((filtc = strfilter (at_Surname,s,SUBSTRINGS ())) == NULLFILTER)
	    return 0;
	filtc -> flt_next = filta;
	if ((filte = strfilter (at_Userid,s,SUBSTRINGS ())) == NULLFILTER)
	    return 0;
	filte -> flt_next = filtc;
	if ((ufn_flags & UFN_APPROX) && !index (s, '*')) {
	    if ((filtb = strfilter (at_CommonName,s,FILTERITEM_APPROX)) == NULLFILTER)
		return 0;
	    filtb -> flt_next = filte;
	    if ((filtd = strfilter (at_Surname,s,FILTERITEM_APPROX)) == NULLFILTER)
		return 0;
	    filtd -> flt_next = filtb;
	    if ((filtf = strfilter (at_Userid,s,FILTERITEM_APPROX)) == NULLFILTER)
		return 0;
	    filtf -> flt_next = filtd;
	    filt = joinfilter (filtf, FILTER_OR);
	}
	else
	    filt = joinfilter (filte, FILTER_OR);

	return ufn_search (base,subtree,filt,result,s,interact,el, TRUE);
}
#endif USELDAP

#ifdef USELDAP
static keyedSearch(base, t, v, interact, el, result)
char * base;
char * t, * v; 
struct namelist * (* interact) ();
struct namelist * el;
struct namelist ** result;
{
    char filt[LINESIZE];

    /* Need to check that t is a valid attribute type!  But how??? */

    if ((ufn_flags & UFN_APPROX) && !index (v, '*'))
	(void)sprintf(filt, "(|(%s=*%s*)(%s~=%s))", t, v, t, v);
    else
	(void)sprintf(filt, "(%s=*%s*)", t, v);

    return ufn_search(base, base != NULLCP && *base != NULL
				      && present (base, SHORT_ORG),
			   filt, result, v, interact, el, FALSE);
}
#else
static keyedSearch (base,t,v,interact,el,result)
DN base;
char * t, *v; 
DNS (* interact) ();
DNS el;
DNS * result;
{
Filter filt, filta, filtb;
AttributeType at;

	if ((at = AttrT_new (t)) == NULLAttrT) {
		NOTIFY (("Invalid Key !"));
		return FALSE;
	}
	if ( ! sub_string (at->oa_syntax)) {
		NOTIFY (("String types only !"));
		return FALSE;
	}

	if ((filta = strfilter (at,v,SUBSTRINGS ())) == NULLFILTER)
	    return 0;
	if ((ufn_flags & UFN_APPROX) && !index (v, '*')) {
	    if ((filtb = strfilter (at,v,FILTERITEM_APPROX)) == NULLFILTER)
		return 0;
	    filtb -> flt_next = filta;
	    filt = joinfilter (filtb, FILTER_OR);
	}
	else
	    filt = filta;

	return ufn_search (base, base && base -> dn_parent
				      && present (base, at_Organisation),
			   filt, result, v, interact, el, FALSE);
}
#endif USELDAP

#ifdef USELDAP
static purportedMatch(base, c, v, interact, el, result)
char * base;
int c;
char ** v;
struct namelist * (* interact) ();
struct namelist * el;
struct namelist ** result;
{
char * s;
struct namelist * root, * x, * new = NULLLIST;
char * ptr;
int matches;
int bad_purported = FALSE;

  s = TidyString (v[c-1]);

  if (c == 1) {
    if ((ptr = index (s, '=')) != NULLCP) {
      *ptr++ = 0;
      matches = keyedSearch (base, SkipSpace(s), SkipSpace(ptr), interact, el, result);
      *(--ptr) = '=';
      return matches;
    } else if (base == NULLCP || *base == '\0') {
      matches = rootSearch(s, interact, el, result);
      if (*result != NULLLIST)
        return matches;
      else if (matches == TRUE)
        return TRUE;
      else
        return leafSearch (base, s, FALSE, interact, el, result);
    } else if (base == NULLCP || *base == '\0'
             || !present(base, SHORT_ORG)) {
      /* length == 1 or still in geography */
      matches = intSearch (base, s, interact, el, result);
      if (*result != NULLLIST)
        return matches;
      else if (matches == TRUE)
        return TRUE;
      else
        return leafSearch (base, s, 
               base == NULLCP || *base == '\0', 
               interact, el, result);
    } else {
      matches = leafSearch (base, s, TRUE, interact, el, result);
      if (*result != NULLLIST)
        return matches;
      else if (matches == TRUE)
        return TRUE;
      else
        return intSearch (base, s, interact, el, result);
    }
  }

  if ((ptr = index (s, '=')) != NULLCP) {
    *ptr++ = 0;
    if ( ! (matches = keyedSearch (base, SkipSpace(s), SkipSpace(ptr), interact, el, &root))) {
      *(--ptr) = '=';
      return FALSE;
    }
    *(--ptr) = '=';
  } else if (base == NULLCP) {
    if ( ! (matches = rootSearch (s, interact, el, &root)))
      return FALSE;
  } else {
    if ( ! (matches = intSearch (base, s, interact, el, &root)))
      return FALSE;
  }

  for (x = root; x != NULLLIST; x = x->next) {
    if (purportedMatch (x->name,  c-1,  v, interact, el, &new)) {
      if (new != NULLLIST)
        *result = DNS_append (*result, new);
    } else
      bad_purported = TRUE;
  }

  if (bad_purported)
    if (*result == NULLLIST)
      return FALSE;
    else
      NOTIFY (("Remote failure: Not all subtrees searched"));

  return matches;
}
#else
static purportedMatch(base,c,v,interact,el,result)
DN base;
int c;
char ** v;
DNS (* interact) ();
DNS el;
DNS * result;
{
char * s;
DNS root, x, new = NULLDNS;
char * ptr;
int matches;
int bad_purported = FALSE;

	s = TidyString (v[c-1]);

	if (c == 1) {

		if ((ptr = index (s,'=')) != NULLCP) {
			*ptr++ = 0;
			matches = keyedSearch (base,SkipSpace(s),SkipSpace(ptr),interact,el,result);
			*(--ptr) = '=';
			return matches;
		} else if (base == NULLDN) {
			matches = rootSearch(s,interact,el,result);
			if (*result != NULLDNS)
				return matches;
			else if (matches == TRUE)
				return TRUE;
			else
				return leafSearch (base,s,FALSE,interact,el,result);
		} else if (base->dn_parent == NULLDN
			       || !present (base, at_Organisation)) {
			/* length == 1 or still in geography */
			matches = intSearch (base,s,interact,el,result);
			if (*result != NULLDNS)
				return matches;
			else if (matches == TRUE)
				return TRUE;
			else
				return leafSearch (base,s,
						   base -> dn_parent == NULLDN,
						   interact,el,result);
		} else {
			matches = leafSearch (base,s,TRUE,interact,el,result);
			if (*result != NULLDNS)
				return matches;
			else if (matches == TRUE)
				return TRUE;
			else
				return intSearch (base,s,interact,el,result);
		}
	}

	if ((ptr = index (s,'=')) != NULLCP) {
		*ptr++ = 0;
		if ( ! (matches = keyedSearch (base,SkipSpace(s),SkipSpace(ptr),interact,el,&root))) {
			*(--ptr) = '=';
			return FALSE;
		}
		*(--ptr) = '=';
	} else if (base == NULLDN) {
		if ( ! (matches = rootSearch (s,interact,el,&root)))
			return FALSE;
	} else {
		if ( ! (matches = intSearch (base,s,interact,el,&root)))
			return FALSE;
	}

	for (x = root; x != NULLDNS; x = x->dns_next) {
		if (purportedMatch (x->dns_dn, c-1, v,interact,el,&new)) {
			if (new != NULLDNS)
				*result = DNS_append (*result,new);
		} else
			bad_purported = TRUE;
	}

	if (bad_purported)
		if (*result == NULLDNS)
		    return FALSE;
		else
		    NOTIFY (("Remote failure: Not all subtrees searched"));
		

	return matches;
}
#endif USELDAP

#ifdef USELDAP
static envMatch (c, v, el, interact, result)
int c;
char ** v;
struct namelist * el;
struct namelist * (* interact) ();
struct namelist ** result;
{
  int res;

  if (el == NULLLIST)
    return TRUE;

  if ( ! ( res = purportedMatch(el->name, c, v, interact, el, result)))
    return FALSE;
  if (*result != NULLLIST)  
    return res;
  if (res == TRUE)
    return TRUE;    

  return envMatch(c, v, el->next, interact, result);
}
#else
static envMatch (c,v,el,interact,result)
int c;
char ** v;
DNS el;
DNS (* interact) ();
DNS * result;
{
int res;

	if (el == NULLDNS)
		return TRUE;

	if ( ! ( res = purportedMatch(el->dns_dn,c,v,interact,el,result)))
		return FALSE;
	if (*result != NULLDNS)	
		return res;
	if (res == TRUE)
		return TRUE;		

	return envMatch(c,v,el->dns_next,interact,result);

}
#endif USELDAP

#ifdef USELDAP
static  friendlyMatch_aux (c, v, el, interact, result)
int c;
char ** v;
envlist el;
struct namelist * (* interact) ();
struct namelist ** result;
{
  if (el == NULLEL)
    return TRUE;

  if ( ( c <= el->Upper) && (c >= el->Lower) ) 
    return envMatch (c, v, el->Dns, interact, result);

  return (friendlyMatch_aux (c, v, el->Next, interact, result));
}
#else
static	friendlyMatch_aux (c,v,el,interact,result)
int c;
char ** v;
envlist el;
DNS (* interact) ();
DNS * result;
{
	if (el == NULLEL)
		return TRUE;

	if ( ( c <= el->Upper) && (c >= el->Lower) ) 
		return envMatch (c,v,el->Dns,interact,result);

	return (friendlyMatch_aux (c,v,el->Next,interact,result));

}
#endif USELDAP

envlist read_envlist()
{
char * home, *p, *ptr;
char ufnrc [LINESIZE];
char * def, *opened;
char buffer [LINESIZE];
envlist env, top = NULLEL, trail = NULLEL;
#ifdef USELDAP
struct namelist * dtail = NULLLIST;
FILE * file;
char * dn;
#else
DNS dtail = NULLDNS;
FILE * file;
DN dn;
#endif USELDAP
int i = 0;

#ifdef DOS
        if ((def = isodefile("de.ufn", 0)) == NULLCP)
                return NULLEL;
        if ((file = fopen(def, "r")) == NULL)
                return NULLEL;
        opened = def;
#else
	if (home = getenv ("UFNRC"))
		(void) strcpy (ufnrc, home);
	else 
		if (home = getenv ("HOME"))
			(void) sprintf (ufnrc, "%s/.ufnrc", home);
		else
			(void) strcpy (ufnrc, "./.ufnrc");

	opened = ufnrc;
	if ((file = fopen (ufnrc,"r")) == 0) {
		def = isodefile("ufnrc",0);
		if ((file = fopen(def,"r")) == 0) {
#ifdef USELDAP
			(void) fprintf (de_log,"Can't open '%s' or '%s'\n",ufnrc,def);
#else
			(void) sprintf (PY_pepy,"Can't open '%s' or '%s'",ufnrc,def);
#endif USELDAP
			return NULLEL;
		}
		opened = def;
	}
#endif DOS

	while (fgets (buffer, LINESIZE, file) != 0) {
		i++;
		p = buffer;
		if (( *p == '#') || (*p == '\0') || (*p == '\n'))
			continue; 	/* ignore comments and blanks */

		if (isspace (*p)) {
			/* part of current environment */
			if (!dtail) {
#ifdef USELDAP
#ifndef DOS
				(void) fprintf (de_log, "Unexpected blank at start of line %d in %s\n",i,opened);
#endif DOS
#else
				(void) sprintf (PY_pepy, "Unexpected blank at start of line %d in %s",i,opened);
#endif USELDAP
				(void) fclose (file);
				return NULLEL;
			}
			p = TidyString(p);
			if (*p == '-')
#ifdef USELDAP
				dn = NULLCP;
			else
				if (index(p, '@') != NULLCP)
					dn = quipuDN2DS23DN(p);
				else	dn = copy_string(p);
			dtail->next = list_alloc();
			dtail = dtail->next;
			dtail->next = NULLLIST;
			dtail->name = dn;
#else
				dn = NULLDN;
			else if ((dn = str2dn (p)) == NULLDN) {
				(void) sprintf (PY_pepy, "Bad DN in environment file (%s) line %d",opened,i);
				(void) fclose (file);
				return NULLEL;
			}
			dtail->dns_next = dn_seq_alloc();
			dtail = dtail->dns_next;
			dtail->dns_next = NULLDNS;
			dtail->dns_dn   = dn;
#endif USELDAP
			continue;
		}

		p = TidyString (p);

		if ((ptr = index (p,':')) == NULLCP) {
#ifdef USELDAP
#ifndef DOS
			(void) fprintf (de_log, "':' missing in environment file (%s) line %d\n",opened,i);
#endif DOS
#else
			(void) sprintf (PY_pepy, "':' missing in environment file (%s) line %d",opened,i);
#endif USELDAP
			(void) fclose (file);
			return NULLEL;
		}

		*ptr++ = 0;
		ptr = SkipSpace (ptr);

		if (*ptr == '-')
#ifdef USELDAP
			dn = NULLCP;
		else
			dn = copy_string(ptr);
		env = (envlist) smalloc (sizeof (*env));
		dtail = env->Dns = list_alloc();
		dtail->next = NULLLIST;
		dtail->name = dn;
#else
			dn = NULLDN;
		else if ((dn = str2dn (ptr)) == NULLDN) {
			(void) sprintf (PY_pepy, "Bad DN in environment file (%s) line %d",opened,i);
			(void) fclose (file);
			return NULLEL;
		}

		env = (envlist) smalloc (sizeof (*env));
		dtail = env->Dns = dn_seq_alloc();
		dtail->dns_next = NULLDNS;
		dtail->dns_dn   = dn;
#endif USELDAP
		env->Next = NULLEL;
		if (top == NULLEL)
			top = env;
		else 
			trail->Next = env;
		trail = env;

		if ((ptr = index (p,',')) != NULLCP) {
			*ptr++ = 0;
			ptr = SkipSpace(ptr);
			if (*ptr == '+')
				env->Upper = 32767;	/* ~= infinity */
			else 
				env->Upper = atoi (ptr);	/* how to test error ? */
		} else
			env->Upper = 0;
		
		p = SkipSpace(p);

		env->Lower = atoi (p);		/* how to test error ? */

		if ( ! env->Upper)
			env->Upper = env->Lower;

	}

	(void) fclose (file);

	return top;
}


#ifdef USELDAP
ufn_match (c, v, interact, result, el)
int c;
char ** v;
#ifdef DOS
struct namelist * (* interact) (struct namelist * dns, char * dn, char * s);
#else
struct namelist * (* interact) ();
#endif DOS
struct namelist ** result;
envlist el;
{
  static int inited = FALSE;

  if ( (!ufnatts) && !(inited = ufn_init()))
    return inited;

  if (el == NULLEL) {
    if ((el = read_envlist ()) == NULLEL) {
#ifndef DOS
      (void) fprintf (de_log, "Can't read environment\n");
#endif DOS
      return 0;
    }
  }

  ufn_abort = FALSE;

  return (friendlyMatch_aux (c, v, el, interact, result));
}
#else
ufn_match (c,v,interact,result,el)
int c;
char ** v;
DNS (* interact) ();
DNS * result;
envlist el;
{
static int inited = FALSE;

	if ( (!ufnas) && !(inited = ufn_init()))
		return inited;
	if (ufn_bad_dsa)
	    dn_free (ufn_bad_dsa), ufn_bad_dsa = NULL;
	if (ufn_partials)
	    dn_seq_free (ufn_partials), ufn_partials = NULL;

	PY_pepy[0] = NULL;
	if (el == NULLEL) {
		if ((el = read_envlist ()) == NULLEL) {
			(void) sprintf (PY_pepy,"Can't read environment");
			return 0;
		}
	}

	ufn_abort = FALSE;

	return (friendlyMatch_aux (c,v,el,interact,result));
}
#endif USELDAP

#ifdef USELDAP
ufn_init ()
{
  if (ufnatts)
    return TRUE;

  addToList(&ufnatts, DE_OBJECT_CLASS);
  addToList(&ufnatts, DE_COUNTRY_NAME);
  addToList(&ufnatts, DE_LOCALITY_NAME);
  addToList(&ufnatts, DE_ORGANISATION_NAME);
  addToList(&ufnatts, DE_ORGANISATIONAL_UNIT_NAME);
  addToList(&ufnatts, DE_FRIENDLY_COUNTRY);
  addToList(&ufnatts, DE_COMMON_NAME);
  addToList(&ufnatts, DE_SURNAME);
  addToList(&ufnatts, "uid");
  return TRUE;
}
#else
ufn_init ()
{
Attr_Sequence as;
int result = TRUE;

	if (ufnas)
	    return result;

	if ((at_ObjectClass = AttrT_new ("ObjectClass")) == NULLAttrT) {
		result = FALSE;
		LLOG (log_dsap,LLOG_EXCEPTIONS,("ObjectClass attribute unknown"));
	}

	if ((at_OrgUnit	= AttrT_new ("ou")) == NULLAttrT) {
		result = FALSE;
		LLOG (log_dsap,LLOG_EXCEPTIONS,("ou attribute unknown"));
	}
	if ((at_Organisation = AttrT_new ("o")) == NULLAttrT) {
		result = FALSE;
		LLOG (log_dsap,LLOG_EXCEPTIONS,("o attribute unknown"));
	}
	if ((at_Locality = AttrT_new ("l")) == NULLAttrT) {
		result = FALSE;
		LLOG (log_dsap,LLOG_EXCEPTIONS,("l attribute unknown"));
	}
	if ((at_CountryName = AttrT_new ("c")) == NULLAttrT) {
		result = FALSE;
		LLOG (log_dsap,LLOG_EXCEPTIONS,("c attribute unknown"));
	}
	if ((at_FriendlyCountryName = AttrT_new ("FriendlyCountryName")) == NULLAttrT) {
		result = FALSE;
		LLOG (log_dsap,LLOG_EXCEPTIONS,("FriendlyCountryName attribute unknown"));
	}
	if ((at_CommonName = AttrT_new (CN_OID)) == NULLAttrT) {
		result = FALSE;
		LLOG (log_dsap,LLOG_EXCEPTIONS,("cn attribute unknown"));
	}
	if ((at_Surname	= AttrT_new ("sn")) == NULLAttrT) {
		result = FALSE;
		LLOG (log_dsap,LLOG_EXCEPTIONS,("sn attribute unknown"));
	}
	if ((at_Userid = AttrT_new ("uid")) == NULLAttrT) {
		result = FALSE;
		LLOG (log_dsap,LLOG_EXCEPTIONS,("uid attribute unknown"));
	}

	ufnas = as_comp_new (at_OrgUnit,NULLAV,NULLACL_INFO);
	as = as_comp_new (at_Organisation,NULLAV,NULLACL_INFO);
	ufnas = as_merge (ufnas,as);
	as = as_comp_new (at_Locality,NULLAV,NULLACL_INFO);
	ufnas = as_merge (ufnas,as);
	as = as_comp_new (at_CountryName,NULLAV,NULLACL_INFO);
	ufnas = as_merge (ufnas,as);
	as = as_comp_new (at_FriendlyCountryName,NULLAV,NULLACL_INFO);
	ufnas = as_merge (ufnas,as);
	as = as_comp_new (at_CommonName,NULLAV,NULLACL_INFO);
	ufnas = as_merge (ufnas,as);
	as = as_comp_new (at_Surname,NULLAV,NULLACL_INFO);
	ufnas = as_merge (ufnas,as);
	as = as_comp_new (at_Userid,NULLAV,NULLACL_INFO);
	ufnas = as_merge (ufnas,as);

	return result;
}
#endif USELDAP

#ifdef DE-DEBUG
#ifdef USELDAP
static	print_search (dn, subtree, fi)
char * dn;
char subtree;
char * fi;
{
  (void) fprintf (stderr, "Searching: %s : %s : %s\n", dn,
				subtree ? "subtree" : "singlelevel",
				fi);
}
#else
static	print_search (dn, subtree, fi)
DN	dn;
char	subtree;
Filter	fi;
{
static	PS	nps = NULLPS;

    if (nps == NULLPS) {
	if ((nps = ps_alloc (std_open)) == NULL) {
	    (void) fprintf (stderr, "ps_alloc(std_open): you lose\n");
	    return;
	}
	if (std_setup (nps, stdout) == NOTOK) {
	    (void) fprintf (stderr, "std_setup(stdout): you lose\n");
	    ps_free (nps);
	    nps = NULL;
	    return;
	}
    }
    
    ps_printf (nps, "search starting at @");
    dn_print (nps, dn, EDBOUT);
    ps_printf (nps, "(%s) for ", subtree ? "subtree" : "singlelevel");

    print_filter (nps, fi, 0);

    ps_print (nps, "\n\n");
    (void) ps_flush (nps);
}
#endif USELDAP
#endif
