/* util.c */

#ifndef lint
static char *rcsid = "$Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/util.c,v 9.3 1993/03/19 22:56:15 isode Exp isode $";
#endif

/*
 * $Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/util.c,v 9.3 1993/03/19 22:56:15 isode Exp isode $
 *
 *
 * $Log: util.c,v $
 * Revision 9.3  1993/03/19  22:56:15  isode
 * Add QOS and DOS-DE code
 *
 * Revision 9.2  1992/12/15  07:05:26  awy
 * Update and fixes
 *
 * Revision 8.1  1991/09/13  14:36:41  isode
 * PARADISE Upgrade release
 *
 * Revision 8.0  91/07/17  13:18:50  isode
 * Release 7.0
 *
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */

#define util_c
#ifdef DOS
#include <stdlib.h>
#include "proto-de.h"
#include <graph.h>
#endif DOS
#include "messages.h"
#include <signal.h>
#ifdef USELDAP
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#ifdef IC
#include <ldap/lber.h>
#include <ldap/ldap.h>
#else
#include <lber.h>
#include <ldap.h>
#endif /* IC */
#include "isomanifest.h"
#endif USELDAP
#include "config.h"
#include "demanifest.h"
#include "destrings.h"
#include "types.h"
#include "util.h"
#include "namelist.h"
#include "cnamelist.h"
#ifndef USELDAP
#include "quipu/util.h"
#include "quipu/ds_search.h"
#ifdef IC
#include "compat/logger.h"
#else
#include "logger.h"
#endif /* IC */
#endif USELDAP
#include "query.h"

extern struct query qinfo[];
#ifdef USELDAP
#ifndef DOS
extern FILE * de_log;
#endif DOS
#else
extern LLog *de_log;
#endif USELDAP
extern int qosOn;
extern int limitProblem;
extern int notAllReached;
extern int localAlarmTime;
extern int remoteAlarmTime;
extern char origDefaultCo[], origDefaultOrg[];
extern int deLogLevel;
extern int alarmCount;
extern int bindTimeout;
extern int gotFuzzyMatch;
void onint1();
void clearDots();

extern int dots;
extern int dotsPrinted;

#ifdef USELDAP
extern LDAP * ldap_ld;
#endif USELDAP

int
listlen(lp)
struct namelist * lp;
{
int len;

  for (len = 0; lp != NULLLIST; lp = lp->next, len++) {};
  return len;
}

unsigned int
alarmLen()
{
#ifdef QOS
extern int secondsAlarm;
#endif QOS

  if ((lexequ(qinfo[ORG].entered, origDefaultOrg) == 0) && 
      (lexequ(qinfo[COUNTRY].entered, origDefaultCo) == 0))
    return localAlarmTime;
  else
  {
      return remoteAlarmTime;
  }
}

void initAlarm()
{
#ifdef USELDAP
/*
  ld->ld_timelimit = alarmLen();
 */
  ldap_ld->ld_timelimit = 180; /* 3 mins ??? */
#endif USELDAP
  dots = alarmLen() / 2;
  dotsPrinted = 0;
}

void
alarmCleanUp()
{
	if (dotsPrinted > 0)
	{
	  if (dotsPrinted < dots)
	    clearDots();
	  else
	    (void) printf("\n\n");
	  dotsPrinted = 0;
	}
}

void
clearDots()
{
int i, len;
#ifdef DOS
struct _rccoord curpos;

  len = strlen(SEARCHMESS) + dotsPrinted;
  curpos = _gettextposition();
  _settextposition(curpos.row, curpos.col - len);
  for (i = 1; i < len + 1; i++)
    _outtext(" ");
  _settextposition(curpos.row, curpos.col - len);
#else
  len = strlen(SEARCHMESS) + dotsPrinted;
  for (i = 0; i < len; i++)
    (void)printf("\b \b");
#endif DOS
}

void
handleTimeout()
{
#ifndef DOS
  de_unbind();
  (void) signal(SIGALRM, SIG_IGN);
#endif DOS
}

void startUnbindTimer()
{
#ifndef DOS
void handleTimeout();

  (void) signal(SIGALRM, (VFP) handleTimeout);
  (void) alarm((unsigned)bindTimeout);
#endif DOS
}

void stopUnbindTimer()
{
#ifndef DOS
  (void) signal(SIGALRM, SIG_IGN);
  (void) alarm(0);
#endif DOS
}

char *
copy_string(string)
char *string;
{
  char *new_string;

  if (string == NULLCP) return NULLCP;

  new_string = (char *) smalloc((strlen(string) + 1));
  (void) strcpy(new_string, string);

  return new_string;
}


#ifndef USELDAP
static PS ps = NULLPS;

char   *dn2pstr (dn)
DN	dn;
{
    char       *cp;

    if (ps == NULL
	    && ((ps = ps_alloc (str_open)) == NULLPS)
		    || str_setup (ps, NULLCP, BUFSIZ, 0) == NOTOK) {
	if (ps)
	    ps_free (ps), ps = NULLPS;

	return NULLCP;
    }

    dn_print (ps, dn, RDNOUT);
    ps_print (ps, " "); 
    *--ps -> ps_ptr = NULL, ps -> ps_cnt++;

    cp = ps -> ps_base;

    ps -> ps_base = NULL, ps -> ps_cnt = 0;
    ps -> ps_ptr = NULL, ps -> ps_bufsiz = 0;

    return cp;
}

char   *rdn2pstr (rdn)
RDN	rdn;
{
    char       *cp;

    if (ps == NULL
	    && ((ps = ps_alloc (str_open)) == NULLPS)
		    || str_setup (ps, NULLCP, BUFSIZ, 0) == NOTOK) {
	if (ps)
	    ps_free (ps), ps = NULLPS;

	return NULLCP;
    }

    rdn_print (ps, rdn, RDNOUT);
    ps_print (ps, " "); 
    *--ps -> ps_ptr = NULL, ps -> ps_cnt++;

    cp = ps -> ps_base;

    ps -> ps_base = NULL, ps -> ps_cnt = 0;
    ps -> ps_ptr = NULL, ps -> ps_bufsiz = 0;

    return cp;
}




/* determine wildcard type of already validated string */

int starstring(istr, ostr1, ostr2)
char * istr, ** ostr1, ** ostr2;
{
char * lastcp, *cp;

  lastcp = istr + strlen(istr) - 1;
  if ((*istr != '*') && (*lastcp == '*')) 
  {
    *lastcp = '\0';
    *ostr1 = istr;
    return LEADSUBSTR;
  } 
  else if ((*istr == '*') && (*lastcp != '*')) 
  {
    *ostr1 = istr + 1;
    return TRAILSUBSTR;
  } 
  else if ((*istr == '*') && (*lastcp == '*')) 
  {
    *lastcp = '\0';
    *ostr1 = istr + 1;
    return ANYSUBSTR;
  } 
  else /* must be of the form foo*bar */
  {
    *ostr1 = istr;
    cp = index(istr, '*');
    *cp = '\0';
    *ostr2 = cp + 1;
    return LEADANDTRAIL;
  }
}
#endif USELDAP


/* print last component of a dn string - optionally indented by type */
void printLastComponent(indent, dnstr, objectType, printNumber)
int indent;
char * dnstr;
int objectType;
int printNumber;
{
char * cp1, * cp2, * savestring;

  if (strcmp(dnstr, "root") == 0)
    return;
  savestring = copy_string(dnstr);
  cp1 = lastComponent(savestring, objectType);
  if (cp1 == NULLCP)
  {
    savestring = copy_string("Entry with no name!");
    cp2 = savestring;
  }
  else
  {
    if (objectType == COUNTRY)
      cp2 = mapCoName(cp1);
    else
      cp2 = cp1;
  }
  if (indent == INDENTON)
  {
    switch (objectType)
    {
      case COUNTRY:
        break;
      case LOCALITY:
        pageprint(" ");
	break;
      case ORG:
        pageprint("  ");
	break;
      case ORGUNIT:
        pageprint("    ");
	break;
      case PERSON:
        pageprint("      ");
	break;
      default:
        (void) fprintf(stderr, "WOT's THIS?  ");
	break;
    }
  }
  if (printNumber != 0)
    pageprint("%3d ", printNumber);
  pageprint("%s%s\n", cp2, 
                      (qinfo[objectType].fuzzy == TRUE) ? FUZZILYMATCHED : "");
/*  pageprint("%s\n", cp2); */
  free(cp1);
  free(savestring);
}

char *
lastComponent(dnstr, objectType)
char * dnstr;
int objectType;
{
char * cp, * cp2, *cp3, * savestring;
int gotmatch;

  if (dnstr == NULLCP)
    return NULLCP;
  if (*dnstr == '\0')
    return NULLCP;
  savestring = copy_string(dnstr);
#ifdef USELDAP
  cp = index(savestring, ',');
  if (cp != NULLCP)
    *cp = '\0';
  cp = index(savestring, '=');
  if (cp != NULLCP)
    cp++;
  else
    cp = savestring;
  cp = copy_string(cp);
#else
  cp = cp3 = rindex(savestring, '@');
  if (cp == NULLCP)
/*    cp = dnstr;*/
    cp = cp3 = dnstr;
  else
    cp++;
  for (;;)
  {
    gotmatch = FALSE;
    switch (objectType)
    {
      case PERSON:
        if (strncmp(cp, SHORT_CN, strlen(SHORT_CN)) == 0)
	{
          cp += strlen(SHORT_CN) + 1;
	  gotmatch = TRUE;
	}
        break;
      case ORGUNIT:
        if (strncmp(cp, SHORT_OU, strlen(SHORT_OU)) == 0)
	{
	  cp += strlen(SHORT_OU) + 1;
	  gotmatch = TRUE;
	}
	break;
      case ORG:
        if (strncmp(cp, SHORT_ORG, strlen(SHORT_ORG)) == 0)
	{
	  cp += strlen(SHORT_ORG) + 1;
	  gotmatch = TRUE;
	}
	break;
      case LOCALITY:
        if (strncmp(cp, SHORT_LOC, strlen(SHORT_LOC)) == 0)
	{
	  cp += strlen(SHORT_LOC) + 1;
	  gotmatch = TRUE;
	}
	break;
      case COUNTRY:
        if (strncmp(cp, SHORT_CO, strlen(SHORT_CO)) == 0)
	{
	  cp += strlen(SHORT_CO) + 1;
	  gotmatch = TRUE;
	}
	else if (strncmp(cp, SHORT_LOC, strlen(SHORT_LOC)) == 0)
	{
	  cp += strlen(SHORT_LOC) + 1;
	  gotmatch = TRUE;
	}
	break;
    }
    cp2 = index(cp, '%');
    if (gotmatch == TRUE)
    {
      if (cp2 != NULLCP)
        *cp2 = '\0';
      break;
    }
    else 
    {
      if (cp2 != NULLCP)
        cp = cp2 + 1;
      else
        break;
    }
  }
  if (gotmatch == FALSE)
  {
    cp = index(cp3, '%');
    if (cp != NULLCP)
      *cp = '\0';
    cp = index(cp3, '=') + 1;
  }
  cp = copy_string(cp);
#endif USELDAP
  free (savestring);
  return cp;
}

char *
orgNameFromDN(dnstr, nameType)
char * dnstr;
int nameType;
{
char * cp, * cp2;
char tmp[100];

  (void)sprintf(tmp, "%s=", SHORT_ORG);
  cp = copy_string(dnstr);
  for (;;)
  {
    if (strncmp(tmp, lastRDN(cp), strlen(tmp)) == 0)
      if (nameType == 0)
        return cp; /* return DN */
      else
        return (lastRDN(cp) + strlen(tmp)); /* just name part */
    cp2 = removeLastRDN(cp);
    free(cp);
    if (cp2 == NULLCP)
      return NULLCP;
    cp = cp2;
  }
}


char *
removeLastRDN(dnstr)
char * dnstr;
{
char * cp, * cp2;

	cp = copy_string(dnstr);
#ifdef USELDAP
        cp2 = index(cp, ',');
        if (cp2 == NULLCP)
		return copy_string("");
        else {
                while (*cp2 == ',' || *cp2 == ' ') cp2++;
                (void)strcpy(cp, cp2);
        }
#else
	if ((cp2 = rindex(cp, '@')) == NULLCP)
	  return NULLCP;
	else
	*cp2 = '\0';
#endif USELDAP
	return cp;
}

char *
lastRDN(dnstr)
char * dnstr;
{
char * cp;

#ifdef USELDAP
char * savestring;

        savestring = copy_string(dnstr);
        cp = index(savestring, ',');
        if (cp == NULLCP)
                return savestring;
        else
        {
                *cp = '\0';
                cp = copy_string(savestring);
                free(savestring);
                return cp;
        }
#else
	cp = rindex(dnstr, '@');
	if (cp == NULLCP)
		return dnstr;
/*		return NULLCP; */
	else
		return (++cp);
#endif USELDAP
}

void
clearProblemFlags()
{
	limitProblem = notAllReached = FALSE;
}

#ifdef USELDAP
void
setProblemFlags(errno)
int errno;
{
        if (errno == LDAP_SIZELIMIT_EXCEEDED)
                limitProblem = TRUE;
        else if (errno == LDAP_TIMELIMIT_EXCEEDED)
                notAllReached = TRUE;
}
#else
void
setProblemFlags(sresult)
struct ds_search_result sresult;
{
	if ((sresult.CSR_limitproblem == LSR_SIZELIMITEXCEEDED) ||
	    (sresult.CSR_limitproblem == LSR_ADMINSIZEEXCEEDED))
		limitProblem = TRUE;
	if ((sresult.CSR_cr != NULLCONTINUATIONREF) ||
	    (sresult.CSR_limitproblem == LSR_TIMELIMITEXCEEDED))
		notAllReached = TRUE;
}
#endif USELDAP


void
showAnyProblems(str)
char * str;
{
    if (limitProblem == TRUE)
    {
      pageprint(LIMIT);
      if (strcmp(str, "*") == 0)
      {
	pageprint(GUESS);
      }
      else
        pageprint(BEPRECISE);
      pageprint(REFER);
    }
    else
    {
      if (notAllReached == TRUE)
      {
        pageprint(NOTALL1);
  	pageprint(NOTALL2);
      }
    }
}


void
logSearchSuccess(outcome, objecttype, string, searchNumber, noMatches)
char * outcome;
char * objecttype;
char * string;
int searchNumber;
int noMatches;
{
char filterNumberString[20];

	if (deLogLevel > 1)
	{
		if (searchNumber == 0)
			(void) strcpy(filterNumberString, "explicit");
		else
			(void) sprintf(filterNumberString, "%d", searchNumber);
		
#ifndef DOS
#ifdef USELDAP
		(void) fprintf (de_log,
			"searchOutcome:%s:%s:%s:%s:%d\n", objecttype,
#else
		(void) ll_log (de_log, LLOG_NOTICE, NULLCP,
			"searchOutcome:%s:%s:%s:%s:%d", objecttype,
#endif USELDAP
			outcome, string, filterNumberString, noMatches);
#endif DOS
	}
}

void logListSuccess(outcome, objecttype, noMatches)
char * outcome;
char * objecttype;
int noMatches;
{
	if (deLogLevel > 1)
	{
#ifndef DOS
#ifdef USELDAP
		(void) fprintf (de_log,
			"listOutcome:%s:%s:%d\n", objecttype, outcome, noMatches);
#else
		(void) ll_log (de_log, LLOG_NOTICE, NULLCP,
			"listOutcome:%s:%s:%d", objecttype, outcome, noMatches);
#endif USELDAP
#endif DOS
	}
}

void logReadSuccess(outcome, objecttype)
char * outcome;
char * objecttype;
{
	if (deLogLevel > 1)
	{
#ifndef DOS
#ifdef USELDAP
		(void) fprintf (de_log,
			"readOutcome:%s:%s\n", objecttype, outcome);
#else
		(void) ll_log (de_log, LLOG_NOTICE, NULLCP,
			"readOutcome:%s:%s", objecttype, outcome);
#endif USELDAP
#endif DOS
	}
}

void
printOrgOUDetails(objectType)
int objectType;
{
  
  if (!((objectType == ORGUNIT) || (objectType == PERSON)))
    return;
  if (objectType == ORGUNIT)
    resetprint(SHOWORG);
  else /* person */
  {
    if (qinfo[ORGUNIT].lp == NULLLIST)
      resetprint(SHOWORG);
    else
      resetprint(SHOWDEPT);
  }
  if (objectType == ORGUNIT)
  {
    printNames(ORG);
    printDetails(ORG, qinfo[ORG].lp);
    return;
  }
  else /* person */
  {
    if (qinfo[ORGUNIT].lp != NULLLIST)
    {
       printNames(ORGUNIT);
       printDetails(ORGUNIT, qinfo[ORGUNIT].lp);
    }
    else
    {
       printNames(ORG);
       printDetails(ORG, qinfo[ORG].lp);
    }
    return;
  }
}
